#!/bin/sh
# the next line restarts using wish \
exec wish "$0" "$@"

# Startppp
# 
# Copyright (C) 1995  Matthias Ott 
#  (msott@cip.informatik.uni-erlangen.de)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#


set direxec	"/usr/local/bin"
set dirlib	"/usr/local/lib"
set dirscripts	"/etc/ppp"
set startppp 1
set startterm 1
set scripts 1
set config 1
set expect 0
set ressource 1

frame .text 
label .text.label -text "Install Startppp:"

frame .buttons
frame .buttons.z1  
entry .buttons.z1.value -width 20 -textvariable direxec
label .buttons.z1.entry -cursor question_arrow -text "Install-directory for executable (/usr/local/bin): "

frame .buttons.z2  
entry .buttons.z2.value -width 20 -textvariable dirlib
label .buttons.z2.entry -cursor question_arrow -text "Install-directory for library (/usr/local/lib): "

frame .buttons.z3  
entry .buttons.z3.value -width 20 -textvariable dirscripts
label .buttons.z3.entry -cursor question_arrow -text "Directory for pppd/term-programs (/etc/ppp): "

frame .buttons.z4
label .buttons.z4.entry -cursor question_arrow -text " Which programs do you want to install:"
checkbutton .buttons.z4.button0 -cursor question_arrow -text "startppp" -variable startppp
checkbutton .buttons.z4.button1 -cursor question_arrow -text "startterm" -variable startterm

frame .buttons.z5 
checkbutton .buttons.z5.button -cursor question_arrow -text "Install <up/down-scripts>" -variable scripts

frame .buttons.z6 
checkbutton .buttons.z6.button -cursor question_arrow -text "Install Config-Files" -variable config

frame .buttons.z7 
checkbutton .buttons.z7.button -cursor question_arrow -text "Install Expect-Files" -variable expect

frame .buttons.z8 
checkbutton .buttons.z8.button -cursor question_arrow -text "Install Ressource-File" -variable ressource

frame .dis
text .dis.display -relief ridge -borderwidth 5 -width 57 -height 10 -takefocus 0 -yscrollcommand ".dis.scroll set"
scrollbar .dis.scroll -takefocus 0 -command ".dis.display yview"

frame .options 
button .options.install -cursor target -text Install -command {install}
button .options.cancel -cursor target -text Cancel -command {exit}

# all the packing

pack .text -side top
pack .text.label -side left
pack .buttons -pady 5
pack .buttons.z1 .buttons.z2 .buttons.z3 .buttons.z4 .buttons.z5 .buttons.z6 .buttons.z7 .buttons.z8 -side top -fill x
pack .buttons.z1.entry -side left
pack .buttons.z1.value -side right -padx 10
pack .buttons.z2.entry -side left
pack .buttons.z2.value -side right -padx 10
pack .buttons.z3.entry -side left
pack .buttons.z3.value -side right -padx 10
pack .buttons.z4.entry -side left
pack .buttons.z4.button0 -side left
pack .buttons.z4.button1 -side left
pack .buttons.z5.button -side left
pack .buttons.z6.button -side left
pack .buttons.z7.button -side left
pack .buttons.z8.button -side left
pack .dis
pack .dis.display -side left
pack .dis.scroll -side right -fill y 
pack .options -side top -fill x -pady 5
pack .options.install -side right -padx 5
pack .options.cancel -side left -padx 5

proc install {} {
  global direxec dirlib dirscripts startppp startterm scripts config expect ressource 	
  upvar #0 env env2
  if {$scripts == 1} {
    if {$startppp == 1} {
      .dis.display insert end "installing startppp scripts: "
      set a [catch {exec cp ppp-down ppp-up options ip-up ip-down $dirscripts}]
      if {$a == 0} {
        .dis.display insert end "OK\n"
        .dis.display yview -pickplace end
      } else {
        .dis.display insert end "ERROR\n"
        .dis.display yview -pickplace end
      }

    }
    if {$startterm == 1} {
      .dis.display insert end "installing startterm scripts: "
      set a [catch {exec cp term-up term-down $dirscripts}]
      if {$a== 0} {
        .dis.display insert end "OK\n"
        .dis.display yview -pickplace end
      } else {
        .dis.display insert end "ERROR\n"
        .dis.display yview -pickplace end
      }

    }
  }
  catch {exec mkdir $dirlib/startppp}

  .dis.display insert end "installing $dirlib/startppp/startppp_interp: "
  set a [catch {exec cp startppp_interp $dirlib/startppp}]
  if {$a== 0} {
    .dis.display insert end "OK\n"
    .dis.display yview -pickplace end
  } else {
    .dis.display insert end "ERROR\n"
    .dis.display yview -pickplace end
  }
  .dis.display insert end "installing $dirlib/startppp/filewidget.tcl: "
  set a [catch {exec cp filewidget.tcl $dirlib/startppp}]
  if {$a== 0} {
    .dis.display insert end "OK\n"
    .dis.display yview -pickplace end
  } else {
    .dis.display insert end "ERROR\n"
    .dis.display yview -pickplace end
  }
  .dis.display insert end "installing $direxec/startppp_info: "
  set a [catch {exec cp startppp_info $direxec}]
  if {$a== 0} {
    .dis.display insert end "OK\n"
    .dis.display yview -pickplace end
  } else {
    .dis.display insert end "ERROR\n"
    .dis.display yview -pickplace end
  }

  .dis.display insert end "installing $dirlib/startppp/startppp-help: "
  set a [catch {exec cp startppp-help $dirlib/startppp}]
  if {$a== 0} {
    .dis.display insert end "OK\n"
    .dis.display yview -pickplace end
  } else {
    .dis.display insert end "ERROR\n"
    .dis.display yview -pickplace end
  }

  .dis.display insert end "installing images: "
  set a [catch {exec cp xterm.ppm eyenc.ppm eyehc.ppm eyert.ppm eyeb1.ppm eyeb2.ppm eyebc.ppm eyelc.ppm eyerc.ppm cancel.ppm pppdown.ppm pppup.ppm $dirlib/startppp}]
  if {$a== 0} {
    .dis.display insert end "OK\n"
    .dis.display yview -pickplace end
  } else {
    .dis.display insert end "ERROR\n"
    .dis.display yview -pickplace end
  }

  set File [open "tmpfile" w+] 
  puts $File "#!$dirlib/startppp/startppp_interp"
  close $File

  .dis.display insert end "installing $dirlib/startppp/startppp_prog: "
  set a [catch {exec cat tmpfile startppp_partial.tcl > $dirlib/startppp/startppp_prog}]
  set b [catch {exec chmod 755 $dirlib/startppp/startppp_prog}]
  if {[expr $a + $b] == 0} {
    .dis.display insert end "OK\n"
    .dis.display yview -pickplace end
  } else {
    .dis.display insert end "ERROR\n"
    .dis.display yview -pickplace end
  }

  if {$startppp == 1} {
    .dis.display insert end "Linking $direxec/startppp: "
    set a [catch {exec rm -f $direxec/startppp}]
    set b [catch {exec ln -s $dirlib/startppp/startppp_prog $direxec/startppp}]
    if {[expr $a + $b] == 0} {
      .dis.display insert end "OK\n"
      .dis.display yview -pickplace end
    } else {
      .dis.display insert end "ERROR\n"
      .dis.display yview -pickplace end
    }
  }

  if {$startterm == 1} {
    .dis.display insert end "Linking $direxec/startterm: "
    exec rm -f $direxec/startterm
    exec ln -s $dirlib/startppp/startppp_prog $direxec/startterm
    if {[expr $a + $b] == 0} {
      .dis.display insert end "OK\n"
      .dis.display yview -pickplace end
    } else {
      .dis.display insert end "ERROR\n"
      .dis.display yview -pickplace end
    }
  }

  set File [open "tmpfile" w+] 
  puts $File $dirlib/startppp
  close $File

  if {$config == 1} {
    catch {exec mkdir $env2(HOME)/.startppp}
    .dis.display insert end "installing  $env2(HOME)/.startppp/startppp_units: "
    set a [catch {exec cp startppp_units $env2(HOME)/.startppp/startppp_units}]
    if {$a== 0} {
      .dis.display insert end "OK\n"
      .dis.display yview -pickplace end
    } else {
      .dis.display insert end "ERROR\n"
      .dis.display yview -pickplace end
    }
    if {$startppp == 1} {
      .dis.display insert end "installing  $env2(HOME)/.startppp/startppp_config: "
      set a [catch {exec cat tmpfile startppp_config > $env2(HOME)/.startppp/startppp_config}]
      if {$a== 0} {
        .dis.display insert end "OK\n"
        .dis.display yview -pickplace end
      } else {
        .dis.display insert end "ERROR\n"
        .dis.display yview -pickplace end
      }
    }
    
    if {$startterm == 1} {
      .dis.display insert end "installing  $env2(HOME)/.startppp/startterm_config: "
      set a [catch {exec cat tmpfile startterm_config > $env2(HOME)/.startppp/startterm_config}]
      if {$a== 0} {
        .dis.display insert end "OK\n"
        .dis.display yview -pickplace end
      } else {
        .dis.display insert end "ERROR\n"
        .dis.display yview -pickplace end
      }
    }
    
    .dis.display insert end "installing  $env2(HOME)/.startppp/startppp_holidays: "
    set a [catch {exec cp startppp_holidays $env2(HOME)/.startppp/startppp_holidays}]
    if {$a== 0} {
      .dis.display insert end "OK\n"
      .dis.display yview -pickplace end
    } else {
      .dis.display insert end "ERROR\n"
      .dis.display yview -pickplace end
    }
  }

  if {$expect == 1} {
    if {$startppp == 1} {
      .dis.display insert end "installing  $env2(HOME)/.startppp/startppp_expect: "
      set a [catch {exec cp startppp_expect $env2(HOME)/.startppp/startppp_expect}]
      if {$a== 0} {
        .dis.display insert end "OK\n"
        .dis.display yview -pickplace end
      } else {
        .dis.display insert end "ERROR\n"
        .dis.display yview -pickplace end
      }
    }
    if {$startterm == 1} {
      .dis.display insert end "installing  $env2(HOME)/.startppp/startppp_expect: "
      set a [catch {exec cp startterm_expect $env2(HOME)/.startppp/startterm_expect}]
      if {$a== 0} {
        .dis.display insert end "OK\n"
        .dis.display yview -pickplace end
      } else {
        .dis.display insert end "ERROR\n"
        .dis.display yview -pickplace end
      }
    }
  }

  exec rm tmpfile

  if {$ressource == 1} {
    .dis.display insert end "installing  $dirlib/startppp/Startppp: "
    set a [catch {exec cp Startppp $dirlib/startppp/Startppp}]
    if {$a== 0} {
      .dis.display insert end "OK\n"
      .dis.display yview -pickplace end
    } else {
      .dis.display insert end "ERROR\n"
      .dis.display yview -pickplace end
    }
  }

}
