/*
 * Startppp
 *
 * Copyright (C) 1995  Matthias Ott 
 *  (msott@cip.informatik.uni-erlangen.de)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include <string.h>
#include "tk.h"
#include <time.h>
#include <unistd.h>
#include <signal.h>
#include <stdlib.h>
#include <fcntl.h>
#include <termios.h>
#include <ctype.h>
#include <errno.h>
#include <nlist.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <sys/param.h>
#include <sys/ioctl.h>

#include "Modem.h"
#include "Common.h"

char dialerror[]="dialerror\n";
char dialkill[]="dialkill\n";
char dialup[]="dialup\n";
char dialconnect[]="dialconnect\n";
char dialend[]="dialend\n";
int fd=-1;
int childpid=-1;
int terminalpid=-1;
int pipefd[2];
int pipeterminalfd[2];
int modempipe[2];
int timeout;
int timeouttime;
int showtermint=1;
extern Tcl_Interp *myinterp;


/*
   **	Function name : alarm_handler
   **
   **	Description :
   **	Input :
   **	Output :
*/
void alarm_handler(int x)
{
  char dialtimeout[]="timeout -> closed line";
  write (pipefd[1], dialtimeout, strlen(dialtimeout));
  timeout=1;
}


/*
   **	Function name : modemdial
   **
   **	Description :
   **	Input : init number
   **	Output :
*/
int modemdial(char *modeminit, char *modemdialstring)
{
  int len,i,ii;
  int number=0;
  char buf[100];
  char buf2[1];
  char action[200];
  char *modemconnect;
  char *modemcarrier;
  char *modembusy;
  char *modemnoanswer;
  char *modemdelayed;
  char *modemnodialtone;
  char *modemerror;
  char *modemnocarrier;
  int again = 1;
  struct sigaction sigalarm={
    alarm_handler,0,0};

  modemconnect=Tcl_GetVar(myinterp, "modemconnect", TCL_GLOBAL_ONLY);
  modemcarrier=Tcl_GetVar(myinterp, "modemcarrier", TCL_GLOBAL_ONLY);
  modembusy=Tcl_GetVar(myinterp, "modembusy", TCL_GLOBAL_ONLY);
  modemdelayed=Tcl_GetVar(myinterp, "modemdelayed", TCL_GLOBAL_ONLY);
  modemnodialtone=Tcl_GetVar(myinterp, "modemnodialtone", TCL_GLOBAL_ONLY);
  modemerror=Tcl_GetVar(myinterp, "modemerror", TCL_GLOBAL_ONLY);
  modemnocarrier=Tcl_GetVar(myinterp, "modemnocarrier", TCL_GLOBAL_ONLY);
  modemnoanswer=Tcl_GetVar(myinterp, "modemnoanswer", TCL_GLOBAL_ONLY);

  
  timeout=0;
  
  if (sigaction(SIGALRM, &sigalarm,NULL)!=0) {
    perror("SIGALRM: ");
  }
    
  i=0;
  ii=0;
  while (i < strlen (modeminit)) {
    if (modeminit[i]=='~') {
      sleep(1);
      ++i;
      continue;
    }
    ii=0;
    while ((modeminit[i]!='^') && (modeminit[i+1]!='M') && (i < strlen (modeminit))) {
      action[ii]=modeminit[i];
      ++i;
      ++ii;
    }
    i=i+2;
    action[ii]='\0';
    write (pipefd[1], action, strlen(action));
    strncat(action,"\r",1); 
    write (fd, action, strlen(action));
  }
  
  /* magic sleep, should change it */
  sleep(2);
  write (pipefd[1], modemdialstring, strlen(modemdialstring));
  write (fd, modemdialstring, strlen(modemdialstring));
  modemwait(modemdialstring);
  
  buf[0]='\0';
  alarm(timeouttime);
  again=0;

  do {
    number=0;
    number=read (modempipe[0], buf2,1);
    if (number == -1) {
      if ((timeout == 0) && (errno==EINTR)) {
	continue;
      }
      if (timeout != 1) {
	alarm(0);
	return 7;
      }
    }
    
    if (number == 0) {
      alarm(0);
      return 7;
    }
    if (timeout == 1) {
      sleep (1);
      write (pipefd[1], dialerror, strlen(dialerror));
      while(1) sleep (1000);
    }
    buf[again]=buf2[0];
    buf[again+1]='\0';
    if (strstr(buf,modembusy)!=NULL) {
      alarm(0);
      return 6;
    }
    if (strstr(buf,modemnoanswer)!=NULL) {
      alarm(0);
      write (pipefd[1], modemnoanswer, strlen(modemnoanswer));
      sleep (1);
      return 7;
    }
    if (strstr(buf,modemdelayed)!=NULL) {
      alarm(0);
      write (pipefd[1], modemdelayed, strlen(modemdelayed));
      sleep (1);
      return 7;
    }
    if (strstr(buf,modemnodialtone)!=NULL) {
      alarm(0);
      write (pipefd[1], modemnodialtone, strlen(modemnodialtone));
      sleep (1);
      return 7;
    }
    if (strstr(buf,modemerror)!=NULL) {
      alarm(0);
      write (pipefd[1], modemerror, strlen(modemerror));
      sleep (1);
      return 7;
    }
    if (strstr(buf,modemnocarrier)!=NULL) {
      alarm(0);
      write (pipefd[1], modemnocarrier, strlen(modemnocarrier));
      sleep (1);
      return 7;
    }
    if (strstr(buf,modemcarrier)!=NULL) {
      alarm(0);
      return 0;
    }
    if (strstr(buf,modemconnect)!=NULL) {
      alarm(0);
      return 0;
    }
    if (again >= 30) {
      alarm(0);
      write (pipefd[1], "ANY ERROR", 9);
      sleep (1);
      return 7;
    }
    ++again;
    
  } while (1);
}

/*
   **	Function name : ModemClose
   **
   **	Description :
   **	Input : modemdevicetail
   **	Output : UNLINK DENIED | CLOSED
*/
int ModemClose(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
  char buf[256];
  struct termios t;
  char *modemdevice;
  char modemdevicetail[100];
  char *modemspeed;
  char *modemparity;
  char *modemstopbits;
  int result;
  
  if (argc != 2) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  }
  if (fd==-1) {
    modemdevice=Tcl_GetVar(interp, "modemdevice", TCL_GLOBAL_ONLY);
    strcpy(modemdevicetail,argv[1]);
    modemspeed=Tcl_GetVar(interp, "modemspeed", TCL_GLOBAL_ONLY);
    modemparity=Tcl_GetVar(interp, "modemparity", TCL_GLOBAL_ONLY);
    modemstopbits=Tcl_GetVar(interp, "modemstopbits", TCL_GLOBAL_ONLY);
    result=modemopen(modemdevice,modemdevicetail,modemspeed,modemparity,modemstopbits);
    if (result==1) {
      interp->result = "can't open LCK.. for reading";
      return TCL_OK;
    }
    if (result==2) {
      interp->result = "LOCK process active";
      return TCL_OK;
    }
    if (result==3) {
      interp->result = "can't delete LCK..";
      return TCL_OK;
    }
    if (result==4) {
      interp->result = "can't open LCK.. for writing";
      return TCL_OK;
    }
    if (result==5) {
      interp->result = "can't open modemdevice";
      return TCL_OK;
    }
    if (result==6) {
      interp->result = "tcget|setattr error";
      return TCL_OK;
    }
  }

  if (tcgetattr(fd,&t) < 0) {
    Tcl_SetVar(myinterp, "message", "tcsetattr is not working", TCL_GLOBAL_ONLY);
  } else {
    t.c_cflag=B0;
    if (tcsetattr(fd,TCSANOW,&t) < 0) {
      Tcl_SetVar(myinterp, "message", "tcgetattr is not working", TCL_GLOBAL_ONLY);
    }
  }

  close (fd);
  fd = -1;
  sprintf(buf,"/usr/spool/locks/LCK..%s",argv[1]);
  if (unlink (buf) != 0) {
    interp->result = "unlink denied";
    return TCL_OK;
  }
  interp->result = "closed line";
  return TCL_OK;
}

/*
**	Function name : ModemHangup
**
**	Description :
**	Input :
**	Output :
*/
int ModemHangup(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
  struct termios t;
  if (argc != 1) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  }
  if (tcgetattr(fd,&t) < 0) {
    return TCL_OK;
  } else {
    t.c_cflag=B0;
    if (tcsetattr(fd,TCSANOW,&t) < 0) {
      return TCL_OK;
    }
  }
  interp->result = "Hangup";
  return TCL_OK;
}

/*
**	Function name : ModemHangup2
**
**	Description :
**	Input :
**	Output :
*/
int ModemHangup2(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
  char *attentionstring;
  if (argc != 1) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  }
  attentionstring=Tcl_GetVar(interp, "attentionstring", TCL_GLOBAL_ONLY);
  sleep(2);
  write(fd,attentionstring,strlen(attentionstring));
  sleep(2);
  write(fd, "ath\r",4);
  
  interp->result = "hangup AttString";
  return TCL_OK;
}


/*
   **	Function name : modemtalk
   **
   **	Description :
   **	Input : file
   **	Output : 1 | 0 
*/
int modemtalk(char *expectfile)
{
  char name[100];
  int len;
  FILE *fd2;
  char dialfile[]="no expectfile";
  
  fd2=fopen(expectfile,"r");
  if (fd2==NULL) {
    write (pipefd[1], dialfile, strlen(dialfile));
    return 1;
  }
  while (fgets(name,100,fd2)!=NULL) {
    len = strlen(name);
    name[len-1]='\0';
    modemwait (name);
    fgets(name,100,fd2);
    write (fd, name, strlen(name));
  }
  fclose (fd2);
  
  return 0;
}

/*
   **	Function name : modemwait
   **
   **	Description :
   **	Input :
   **	Output :
*/
int modemwait(char *name)
{
  int r;
  int i;
  int number=0;
  char buf[5000];
  char myname[100];
  struct sigaction sigalarm={
    alarm_handler,0,0};
  strcpy(myname,name);
  r=0;
  
  timeout=0;
  if (sigaction(SIGALRM, &sigalarm,NULL)!=0) {
    perror("SIGALRM: ");
  }
  alarm(timeouttime);
  do {
    number=0;
    number=read (modempipe[0], &buf[r],1);
    
    if ((number == -1) && (timeout == 0)) {
      alarm(0);
      write (pipefd[1], dialerror, strlen(dialerror));
      while(1) sleep (1000);
    }
    if (timeout == 1) {
      write (pipefd[1], dialerror, strlen(dialerror));
      while(1) sleep (1000);
    }
    buf[r+1]='\0';
    
    if (buf[r]=='\0') {
      buf[r]==' ';
    }
    r++;
    if (r >= 5000) {
      r = 0;
    }
  } while ((strstr(buf, myname)==NULL) && (timeout == 0));
  alarm(0);
  return 0;
}

/*
   **	Function name : modemopen
   **
   **	Description :
   **	Input : device lock
   **	Output : 
*/
int modemopen(char *modemdevice, char *modemdevicetail, char *modemspeed, char *modemparity, char *modemstopbits)
{
  FILE *fp;
  char buf[256];
  int pid=0;
  struct termios t;
  
  sprintf(buf,"/usr/spool/locks/LCK..%s",modemdevicetail);
  fp = fopen(buf, "r");
  if (fp == NULL) {
    if (errno != ENOENT) {
      return 1;
    }
  } 
  else {
    fscanf(fp, "%d", &pid);
    fclose (fp);
    if (getpid()!=pid) {
      if (kill(pid,0)==0) {
	return 2;
      }
    }
    else {
      if (unlink (buf) != 0) {
	return 3;
      }
    }
  }
  fp = fopen(buf,"w");
  if (fp == NULL) {
    return 4;
  }
  fprintf(fp,"%d\n",getpid());
  fclose(fp);
  
  fd = open(modemdevice, O_RDWR);
  if (fd<0) {
    printf("MODEM open error\n");
    return 5;
  }
  fcntl(fd,F_SETFL,O_RDWR);
  if (tcgetattr(fd,&t)<0) {
    perror("tcgetattr not working");
    close(fd);
    fd = -1;
    return 6;
  }
  t.c_iflag=t.c_oflag=t.c_lflag=0;
  t.c_cc[VMIN]=1;
  t.c_cc[VTIME]=0;
  
  /* Setzen der Flags */
  if (strcmp(modemparity, "CS8")==0) t.c_cflag = CREAD | CS8;
  if (strcmp(modemparity, "CS8|PARENB ")==0) t.c_cflag = CREAD | CS8 | PARENB;
  if (strcmp(modemparity, "CS8|PARENB|PARODD")==0) t.c_cflag = CREAD | CS8 | PARENB | PARODD;
  
  if (strcmp(modemspeed, "38400")==0) t.c_cflag |= B38400;
  if (strcmp(modemspeed, "19200")==0) t.c_cflag |= B19200;
  if (strcmp(modemspeed, "9600")==0) t.c_cflag |= B9600;
  if (strcmp(modemspeed, "1200")==0) t.c_cflag |= B1200;
  
  if (strcmp(modemstopbits, "CSTOPB")==0) t.c_cflag |= CSTOPB;
  t.c_cflag |= HUPCL;
  /*  t.c_cflag=CREAD | CS8 | B38400 | HUPCL;*/
  if (tcsetattr(fd,TCSANOW,&t)<0) {
    perror("tcsetattr not working");
    close(fd);
    fd = -1;
    return 6;
  }
  return 0;
  
}



/*
   **	Function name : TalkTerminal
   **
   **	Description :
   **	Input :
   **	Output :
*/
void TalkTerminal(ClientData clientData, int mask)
{
  char count,i;
  char input[1000];
  char order[1000];
  char order2[]=".sm.input.text yview -pickplace end\n";
  char order3[]="bell\n";
  char order4[]=".sm.input.text delete {end - 2 chars}";
  char order5[]=".sm.input.text delete {insert linestart} end";
  char order6[]=".sm.input.text insert end \n";
  
  if ((count=read(pipeterminalfd[0], input, 100))<1) {
    return;
  }
    
  for (i=0;i<count;++i) { 
    if (input[i]=='\r') {
      input[i]='\0';
      /*
	 Tcl_Eval (myinterp, order5);
	 Tcl_Eval (myinterp, order6);
      */
    }
    if (input[i]=='\a') {
      input[i]='\0';
      Tcl_Eval (myinterp, order3);
    }
    if (input[i]=='\b') {
      input[i]='\0';
      Tcl_Eval (myinterp, order4);
    }
    
    sprintf(order,".sm.input.text insert end {%c}",input[i]);
    Tcl_Eval (myinterp, order);
    Tcl_Eval (myinterp, order2);
  }
}
  
/*
   **	Function name : TalkProc
   **
   **	Description :
   **	Input :
   **	Output :
*/
void TalkProc(ClientData clientData, int mask)
{
  int i;
  int count;
  char *buf; 
  int bufint;
  char up2[]="up2";
  char startonlinetime[]="startonlinetime";
  char input[100];
  char order [100];
  char *modemdevicetail;
  char *startcommand;
  
  count=read (pipefd[0], input, 100);
 
  if (count <=0) {
    printf("ERROR reading PIPE");
    return;
  }
  input[count]='\0';
  
  /* increase dialtry +1 */
  if (strstr(input, dialup)!=NULL) {
    buf=Tcl_GetVar(myinterp, "dialtry", TCL_GLOBAL_ONLY);
    Tcl_GetInt(myinterp, buf, &bufint);
    ++bufint;
    sprintf(buf,"%d",bufint); 
    Tcl_SetVar(myinterp, "dialtry", buf, TCL_GLOBAL_ONLY);
    return;
  }
  
  /* error while dialing, close modemline */
  if (strstr(input, dialerror)!=NULL) {
    Tcl_SetVar(myinterp, "message", "DIAL ERROR", TCL_GLOBAL_ONLY);
    Tcl_SetVar(myinterp, "dialtry", "0", TCL_GLOBAL_ONLY);
    modemdevicetail=Tcl_GetVar(myinterp, "modemdevicetail", TCL_GLOBAL_ONLY);
    sprintf(order,"modemhangup");
    Tcl_Eval (myinterp, order);
    pidkill();
    return;
  }
  
  /* error, only kill childprocess */
  if (strstr(input, dialkill)!=NULL) {
    Tcl_SetVar(myinterp, "dialtry", "0", TCL_GLOBAL_ONLY);
    pidkill();
    return;
  }
  
  /* got a connect, set LINE up, start onlinetime */
  if (strstr(input, dialconnect)!=NULL) {
    Tcl_SetVar(myinterp, "message", "connected", TCL_GLOBAL_ONLY);
    Tcl_SetVar(myinterp, "dialtry", "0", TCL_GLOBAL_ONLY);
    Tcl_SetVar(myinterp, "linestatus", "LINE up", TCL_GLOBAL_ONLY);
    Tcl_Eval (myinterp, startonlinetime);
    return;
  }
  
  /* sucessfull dialing, start <up2> */
  if (strstr(input, dialend)!=NULL) {
    Tcl_Eval (myinterp, up2);
    Tcl_SetVar(myinterp, "pid", "0", TCL_GLOBAL_ONLY);
    pidkill();
    return;
  }
  
  Tcl_SetVar(myinterp, "message", input, TCL_GLOBAL_ONLY);
  return;
}



/*
   **	Function name : DialProc
   **
   **	Description :
   **	Input :
   **	Output :
*/
int DialProc(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
  int pid;
  char *modemdevice;
  char *modemdevicetail;
  char *modemspeed;
  char *modemparity;
  char *modemstopbits;
  char *modemtimeout;
  char *showterminal;
  int result;
  if (childpid != -1) {
    interp->result="line already active";
    return TCL_OK;
  }
  
  modemdevice=Tcl_GetVar(interp, "modemdevice", TCL_GLOBAL_ONLY);
  modemdevicetail=Tcl_GetVar(interp, "modemdevicetail", TCL_GLOBAL_ONLY);
  modemspeed=Tcl_GetVar(interp, "modemspeed", TCL_GLOBAL_ONLY);
  modemparity=Tcl_GetVar(interp, "modemparity", TCL_GLOBAL_ONLY);
  modemstopbits=Tcl_GetVar(interp, "modemstopbits", TCL_GLOBAL_ONLY);
  modemtimeout=Tcl_GetVar(interp, "modemtimeout", TCL_GLOBAL_ONLY);
/*
   showterminal=Tcl_GetVar(interp, "showterminal", TCL_GLOBAL_ONLY);
   Tcl_GetInt(interp, showterminal, &showtermint);
*/
  Tcl_GetInt(interp, modemtimeout, &timeouttime);
  /* open the modemdevice */
  result=modemopen(modemdevice,modemdevicetail,modemspeed,modemparity,modemstopbits);
  if (result==1) {
    interp->result = "can't open LCK.. for reading";
    return TCL_OK;
  }
  if (result==2) {
    interp->result = "LOCK process active";
    return TCL_OK;
  }
  if (result==3) {
    interp->result = "can't delete LCK..";
    return TCL_OK;
  }
  if (result==4) {
    interp->result = "can't open LCK.. for writing";
    return TCL_OK;
  }
  if (result==5) {
    interp->result = "can't open modemdevice";
    return TCL_OK;
  }
  if (result==6) {
    interp->result = "tcget|setattr error";
    return TCL_OK;
  }

  /* forking */
  if ((pid = fork()) > 0) {  /* parent process  */
    myinterp=interp;
    
    /* set childpid on pid */
    childpid=pid;
    sprintf(interp->result,"%d",childpid);
    return TCL_OK;
  }
  else {
    if (pid == 0) {  /* child process */
      
      int i;
      char *dialtype;
      char *modemnumber;
      char *modeminit;
      char *modemdialstring;
      char *expectfile;
      char *dialtry;
      char *repeatdelay;
      char dialbusy[]="line is busy";
      char dialerror2[]="error while dialing";
      char *numbernumbers2;
      char *tempnumber;
      char *modemfirstinit;
      char numbercounter[4];
      int numbernumbers;
      char **modemnumbers;
      int delay;
      int dialint;
      int iter;
      
      repeatdelay=Tcl_GetVar(interp, "repeatdelay", TCL_GLOBAL_ONLY);
      Tcl_GetInt(interp, repeatdelay, &delay);
      dialtype=Tcl_GetVar(interp, "dialtype", TCL_GLOBAL_ONLY);
      modemnumber=Tcl_GetVar(interp, "modemnumber", TCL_GLOBAL_ONLY);
      modeminit=Tcl_GetVar(interp, "modeminit", TCL_GLOBAL_ONLY);
      modemfirstinit=Tcl_GetVar(interp, "modemfirstinit", TCL_GLOBAL_ONLY);
      expectfile=Tcl_GetVar(interp, "expectfile", TCL_GLOBAL_ONLY);

      numbernumbers2=Tcl_GetVar(interp, "numbernumbers", TCL_GLOBAL_ONLY);
      Tcl_GetInt(interp, numbernumbers2, &numbernumbers);
      modemnumbers=malloc(10);
      for (i=1;i<=numbernumbers;++i) {
	sprintf(numbercounter,"%d",i);
	tempnumber=Tcl_GetVar2(interp, "dialnumbers",numbercounter, TCL_GLOBAL_ONLY);
	if ((modemnumbers=realloc(modemnumbers,i*sizeof(char*)))==NULL) {
	perror("");
	exit (-1);
	}
	modemdialstring=malloc(6+strlen(dialtype)+strlen(tempnumber));
	sprintf(modemdialstring,"ATD%s%s\r",dialtype,tempnumber);
	modemnumbers[i-1]=strdup(modemdialstring);
	free(modemdialstring);
      }
      iter = -1;
      while (1) {
	++iter;
	if (iter >= numbernumbers) {
	  iter = 0;
	}
	dialtry=Tcl_GetVar(interp, "dialtry", TCL_GLOBAL_ONLY);
	Tcl_GetInt(interp, dialtry, &dialint);
	++dialint;
	sprintf(dialtry,"%d",dialint);
	write (pipefd[1], dialup, strlen(dialup));
	
	if (dialint == 1) {
	  result=modemdial(modemfirstinit, modemnumbers[iter]);
	} else {
	  result=modemdial(modeminit, modemnumbers[iter]);
	}

	if (result == 0) {
	  write (pipefd[1], dialconnect, strlen(dialconnect));
	  if (modemtalk(expectfile)!=0) {
	    write (pipefd[1], dialerror, strlen(dialerror));
	    while(1) sleep (1000);
	  }
	}
	if (result == 6) { /* BUSY */
	  write (pipefd[1], dialbusy, strlen(dialbusy));
	  sleep(delay);
	  continue;
	}  
	if (result == 7) { /* ERROR */
	  write (pipefd[1], dialerror, strlen(dialerror));
	  while(1) sleep (1000);
	}
	break;
      }
      write (pipefd[1], dialend, strlen(dialend));
      while(1) sleep (1000);
    }
    else { /* <fork> error */
      interp->result = "fork error";
      return TCL_OK;
    }
  }
}

/*
   **	Function name : KillPid
   **
   **	Description :
   **	Input :
   **	Output :
*/
int KillPid(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
  if (argc != 1) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  }
  
  if (childpid==-1) {
    interp->result = "child not active";
    return TCL_OK;
  }

  /* close the handler */
/*
  Tk_DeleteFileHandler(pipefd[0]);
  close (pipefd[0]);
  close (pipefd[1]);
  if (showtermint == 1) {
    Tk_DeleteFileHandler(pipeterminalfd[0]);
    close (pipeterminalfd[0]);
    close (pipeterminalfd[1]);
  }
*/
  /* kill child */
  if (kill (childpid, 2)==0) {
    waitpid (childpid,NULL,0);
    childpid=-1;
    interp->result = "killed child process";
    return TCL_OK;
  }
  interp->result = "failed to kill child";
  return TCL_OK;
}

/*
**	Function name : KillTerminal
**
**	Description :
**	Input :
**	Output :
*/
int KillTerminal(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
  if (argc != 1) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  }
  
  if (terminalpid==-1) {
    interp->result = "    ";
    return TCL_OK;
  }

  /* kill child */
  if (kill (terminalpid, 2)==0) {
    waitpid (terminalpid,NULL,0);
    terminalpid=-1;
    Tcl_SetVar(interp, "terminalpid", "-1", TCL_GLOBAL_ONLY);
    interp->result = "killed terminal process";
    return TCL_OK;
  }
  interp->result = "failed to kill terminal";
  return TCL_OK;
}


/*
   **	Function name : pidkill
   **
   **	Description :
   **	Input :
   **	Output :
*/
void pidkill(void)
{
/*
  Tk_DeleteFileHandler(pipefd[0]);
  close (pipefd[0]);
  close (pipefd[1]);

  if (showtermint == 1) {
    Tk_DeleteFileHandler(pipeterminalfd[0]);
    close (pipeterminalfd[0]);
    close (pipeterminalfd[1]);
  }
*/
  if(kill(childpid, 2)==0) {
    waitpid(childpid,NULL,0);
    childpid=-1;
  }
}

/*
**	Function name : SendModem
**
**	Description :
**	Input :
**	Output :
*/
SendModem(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
  if (argc != 2) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  }
  
  if (terminalpid < 1) {
    interp->result = "OK";
    return TCL_OK;
  }

  if (argv[1][0]=='\0') {
    interp->result = "OK";
    return TCL_OK;
  }
  if (fd != -1) {
    write (fd, argv[1],1);
  }
  interp->result = "OK";
  return TCL_OK;
}

/*
**	Function name : ModemInit
**
**	Description :
**	Input :
**	Output :
*/
int ModemInit(ClientData clientData, Tcl_Interp *interp, int argc, char *argv[])
{
  char *modemdevice;
  char *modemdevicetail;
  char *modemspeed;
  char *modemparity;
  char *modemstopbits;
  int pid;
  int result;
  
  if (argc != 1) {
    interp->result = "wrong # args";
    return TCL_ERROR;
  }
  myinterp = interp;
  
  modemdevice=Tcl_GetVar(interp, "modemdevice", TCL_GLOBAL_ONLY);
  modemdevicetail=Tcl_GetVar(interp, "modemdevicetail", TCL_GLOBAL_ONLY);
  modemspeed=Tcl_GetVar(interp, "modemspeed", TCL_GLOBAL_ONLY);
  modemparity=Tcl_GetVar(interp, "modemparity", TCL_GLOBAL_ONLY);
  modemstopbits=Tcl_GetVar(interp, "modemstopbits", TCL_GLOBAL_ONLY);

  /* Pipes are initiated */
  if (pipe(pipefd) == -1) {
    interp->result="pipe_error";
    return TCL_OK;
  }
  if (fcntl(pipefd[0],F_SETFL,O_NONBLOCK) == -1) {
    interp->result="fcntl_error";
    return TCL_OK;
  }

  if (pipe(modempipe) == -1) {
    interp->result="pipe_error";
    return TCL_OK;
  }

  if (showtermint == 1) {
    if (pipe(pipeterminalfd) == -1) {
      interp->result="pipe_error";
      return TCL_OK;
    }
    if (fcntl(pipeterminalfd[0],F_SETFL,O_NONBLOCK) == -1) {
      interp->result="fcntl_error";
      return TCL_OK;
    }
  }

  /* Create Filehandler */
  Tk_CreateFileHandler(pipefd[0],TK_READABLE,TalkProc,(ClientData) NULL); 
  
  /* show terminal */
  if (showtermint == 1) {
    Tk_CreateFileHandler(pipeterminalfd[0],TK_READABLE,TalkTerminal,(ClientData) NULL); 
  }

  /* open the modemdevice */
  result=modemopen(modemdevice,modemdevicetail,modemspeed,modemparity,modemstopbits);
  if (result==1) {
    interp->result = "can't open LCK.. for reading";
    write (pipefd[1], "can't open LCK.. for reading", 28);
    return TCL_OK;
  }
  if (result==2) {
    interp->result = "LCK process active";
    write (pipefd[1], "LOCK process active", 19);
    return TCL_OK;
  }
  if (result==3) {
    interp->result = "can't delete LCK..";
    write (pipefd[1], "can't delete LCK..", 18);
    return TCL_OK;
  }
  if (result==4) {
    interp->result = "can't open LCK.. for writing";
    write (pipefd[1], "can't open LCK.. for writing", 28);
    return TCL_OK;
  }
  if (result==5) {
    interp->result = "can't open modemdevice";
    write (pipefd[1], "can't open modemdevice", 22);
    return TCL_OK;
  }
  if (result==6) {
    interp->result = "tcget|setattr error";
    write (pipefd[1], "tcget|setattr error", 19);
    return TCL_OK;
  }
  
  /* forking */
  if ((pid = fork()) > 0) {  /* parent process  */
/*    myinterp=interp; */
    
    /* set terminalpid on pid */
    terminalpid=pid;
    sprintf(interp->result,"%d",terminalpid);
    return TCL_OK;
  }
  else {
    if (pid == 0) {  /* child process */
      {
	int len;
	struct termios t, save_t;
	char buf[1];
	
	do {
	  len=read(fd,buf,1);
	  if (len>0) {
	    write (pipeterminalfd[1], buf, 1);
	    write (modempipe[1], buf, 1);
	  }
	}
      	while (1);
      }
      
    }
    else { /* <fork> error */
      interp->result = "fork error";
      return TCL_OK;
    }
  }
}


