#
# Startppp
# 
# Copyright (C) 1995  Matthias Ott 
#  (msott@cip.informatik.uni-erlangen.de)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#
#  Widgetset fr einen Fileselektor 
#
#  Syntax: 
#    <filename> Load-Save {load|save|merge}
#    Variable $backcolor fr Hintergrundfarbe wird untersttzt
#    Variable $activecolor fr Aktiv-Rahmen wird untersttzt
#
#  deldata $widgetname
#

#  Laden einer Datei

set LoadSavereturn ""

proc Load-Save {command default} {
  global filename backcolor activecolor LoadSavereturn
  if ![info exists backcolor] {set backcolor "cyan"}
  if ![info exists activecolor] {set activecolor "yellow"}
  switch $command { 
    save  {set message "Save the file:"} 
    load  {set message "Load a file:"}
    merge {set message "Merge a file:"}
  }

  set filename [file tail $default]
  catch {cd [file dirname $default]}

  toplevel .filewidget -cursor cross -bg $backcolor

# Windowmanagerhinweise
  
  wm transient .filewidget .

  label .filewidget.message -bg $backcolor -text $message -relief ridge -bd 2
  listbox .filewidget.dateien -highlightbackground $activecolor -background grey -cursor top_left_arrow -relief sunken -bd 2 -yscrollcommand ".filewidget.scroll1 set"
  scrollbar .filewidget.scroll1 -width 10 -bg blue -activebackground darkblue -highlightthickness 0 -troughcolor $backcolor -cursor sb_v_double_arrow -command ".filewidget.dateien yview"
  listbox .filewidget.dir -highlightbackground $activecolor -background grey -cursor top_left_arrow -relief sunken -bd 2 -yscrollcommand ".filewidget.scroll2 set"
  scrollbar .filewidget.scroll2 -width 10 -bg blue -activebackground darkblue -highlightthickness 0 -troughcolor $backcolor -cursor sb_v_double_arrow -command ".filewidget.dir yview"
  frame .filewidget.frame -bg $backcolor -height 5 -width 40
  button .filewidget.frame.button -highlightbackground $activecolor -activebackground darkred -background red -cursor question_arrow -text "Cancel" -command "destroy .filewidget" 
  button .filewidget.frame.button2 -highlightbackground $activecolor -activebackground darkred -background red -cursor question_arrow -text "$command" -command {
    set LoadSavereturn $filename
    destroy .filewidget
  }
  label .filewidget.frame.label -bg $backcolor -text "Filename:"
  entry .filewidget.frame.entry -highlightbackground $activecolor -bg yellow -cursor hand2 -width 15 -relief sunken -bd 2 -textvariable filename
  
  pack .filewidget.message -side top -fill x
  pack .filewidget.frame -side bottom -fill x 
  pack .filewidget.frame.label .filewidget.frame.entry -side left -padx 1m -pady 2m
  pack .filewidget.frame.button -side right -padx 2
  pack .filewidget.frame.button2 -side right -padx 2
  pack .filewidget.dir -side left
  pack .filewidget.scroll2 -side left -fill y
  pack .filewidget.dateien -side left
  pack .filewidget.scroll1 -side left -fill y
  
  dirshow 

  set oldfocus [focus]
  focus .filewidget.frame.entry  

  bind .filewidget.dir <Double-Button-1> {
    catch {set Sel [selection get]}
    if {$Sel != ""} {
      catch {cd [lindex $Sel 0]}
      dirshow
    }    
  }

#  bind .filewidget.dateien <Double-Button-1> {
#  catch {set LoadSavereturn [lindex [selection get] 0]}
#  destroy .filewidget
#  }

  bind .filewidget.frame.entry <Return> {
  set LoadSavereturn [.filewidget.frame.entry get]
  destroy .filewidget
  }  
   
  bind .filewidget.dateien <Double-Button-1> {
  catch {set filename [lindex [selection get] 0]}
  }

  wm geometry .filewidget +300+300
  grab .filewidget
  tkwait window .filewidget   
  focus $oldfocus
  return $LoadSavereturn
  }

proc dirshow {} {
  deldata .filewidget.dir
  deldata .filewidget.dateien
  foreach i [lsort [glob -nocomplain .*]] {
    if {[file isdirectory $i] == 1} {
      .filewidget.dir insert end $i
      continue
    }
    .filewidget.dateien insert end $i
  }
  foreach i [lsort [glob -nocomplain *]] {
    if {[file isdirectory $i] == 1} {
      .filewidget.dir insert end $i
      continue
    }
    .filewidget.dateien insert end $i
  }
}

proc deldata widgetname {
  set Laenge [$widgetname size]
  for {set i 0} {$i < $Laenge} {incr i 1} {
    $widgetname delete 0
  }
}

