#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <net/ppp_defs.h>
#include <net/if.h>
#include <net/if_ppp.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/types.h>

/* Header-Dateien fuer die verwendeten Widgetklassen einbinden
 */
#include <X11/Intrinsic.h>	/* Intrinsics Definitions */
#include <X11/StringDefs.h>	/* Standard Name-String definitions */
#include <X11/Shell.h>

#include <X11/Xaw/Form.h>
#include <X11/Xaw/Label.h>
#include <X11/Xaw/StripChart.h>
#include <X11/cursorfont.h>


/* Fallback-Ressourcen (nur das Notwendigste)
 */
static String fallbackRessources[] = {
  "*sgiMode: true",
  "*useSchemes: all",
   NULL
};

int i = 0;
Widget buttonW;
int s = -1; /* socket file descriptor */
#define FALSE 0
#define TRUE 1
struct ppp_stats old;
int oldin = 0;
int oldout = 0;

int start () {
  if (s != -1) {
    return FALSE;
  }

  if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
    perror("couldn't create IP socket");
    s == -1;
    return FALSE;
  }

  memset(&old, 0, sizeof(old));

  return TRUE;
}

int stop () {
  if (s == -1) {
    return FALSE;
  }

  if (shutdown(s, 2) == -1) {
    if (errno == EBADF) {
    }
    if (errno == ENOTSOCK) {
    }
    if (errno == ENOTCONN) {
    }
    
  }
  s = -1;
  
  return TRUE;

}

int get_info (int *in, int *out) {
  char buf[10];
  register int line = 0;
  struct ppp_stats cur;

  if (s == -1) {
    if (start() == FALSE) {
    return FALSE;
    }
  }

  if (get_stats(&cur) == -1) {
    return FALSE;
  }

  *in = (line % 20? cur.p.ppp_ibytes - old.p.ppp_ibytes: cur.p.ppp_ibytes);

  *out =(line % 20? cur.p.ppp_obytes - old.p.ppp_obytes: cur.p.ppp_obytes);

  return TRUE;
}

int get_stats(struct ppp_stats *curp) {
  struct ifpppstatsreq req;
  
  memset (&req, 0, sizeof (req));
  
  req.stats_ptr = (caddr_t) &req.stats;
  
  sprintf(req.ifr__name, "ppp0");
  if (ioctl(s, SIOCGPPPSTATS, &req) < 0) {
    if (errno == ENOTTY)
      fprintf(stderr, "ppp0: kernel support missing\n");
    return -1;
  }
  *curp = req.stats;
  
  return 0;
}


void getInLoadCB(Widget widget, XtPointer clientData, XtPointer chartValue)
{
  int in, out;
  double * value = (double *) chartValue;

  if (get_info(&in, &out) == FALSE) {
    *value = 0.0;
    return;
  }
  *value = (in - oldin) / 1000.0;
  oldin = in;
}

void getOutLoadCB(Widget widget, XtPointer clientData, XtPointer chartValue)
{
  int in, out;
  double *value = (double *) chartValue;

  if (get_info(&in, &out) == FALSE) {
    *value = 0.0;
    return;
  }
  *value = (out - oldout) / 1000.0;
  oldout = out;
}


void main(int argc, char **argv) {
  Widget mainW, inW, outW;
  XtAppContext kontext;              /* Applikations-Umgebung */
  Widget   applShell;      /* Applikations-Shell */
  int ctype0 = XC_spider;
  int ctype1 = XC_coffee_mug;
  int ctype2 = XC_spraycan;
  Cursor cursor;

  start();

  XtSetLanguageProc(NULL,NULL,NULL);

  applShell = XtVaAppInitialize (&kontext, "ToggleProg",
				 NULL,0,
				 &argc, argv,
				 fallbackRessources,
				 XtNminWidth, 55,
				 XtNminHeight, 55,
				 (Arg*)NULL, 0);
  

  /* XmMainWindow-Widget erzeugen
   */
  cursor = XCreateFontCursor(XtDisplay(applShell),ctype1);
  mainW = XtVaCreateManagedWidget ("mainwindow", formWidgetClass, applShell, 
				   XtNcursor, ctype0,
				   NULL);

  cursor = XCreateFontCursor(XtDisplay(applShell),ctype1);


  inW = XtVaCreateManagedWidget ("Set", stripChartWidgetClass,
				 mainW,
				 XtNcursor, cursor,
				 XtNupdate, 1,
				 XtNjumpScroll, 1,
				 NULL);
  XtAddCallback(inW, XtNgetValue, getInLoadCB, NULL );

  outW = XtVaCreateManagedWidget ("Set", stripChartWidgetClass,
				  mainW,
				  XtNfromVert, inW,
				  XtNcursor, cursor,
				  XtNupdate, 1,
				  XtNjumpScroll, 1,
				  NULL);

  XtAddCallback(outW, XtNgetValue, getOutLoadCB, NULL );


  XtManageChild(mainW);
  XtRealizeWidget (applShell);

  XtAppMainLoop (kontext);

}

