#
# Startppp
# 
# Copyright (C) 1995  Matthias Ott 
#  (msott@cip.informatik.uni-erlangen.de)
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.
# 
# You should have received a copy of the GNU Library General Public
# License along with this program; if not, write to the Free
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#

set progname [file tail $argv0]
set icontext "down"
set version "v1.31"
set instdir "/usr/local/lib/startppp"
set moneyfile "$env(HOME)/.startppp/${progname}_money"
set transferfile "$env(HOME)/.startppp/${progname}_transfer"
set configfile "$env(HOME)/.startppp/${progname}_config"
set expectfile "$env(HOME)/.startppp/${progname}_expect"
set unitsfile "$env(HOME)/.startppp/${progname}_units"
set helpfile "$instdir/startppp-help"
set Ressource "$instdir/Startppp"
set widgetfile "filewidget.tcl"
set onlinetime "00:00:00"; 		# how long are you online
set lastonlinetime "00:00:00";		# time to next unit
set starttime 0;
set infoprog "startppp_info";
set modemdevice /dev/modem;		# modem to use
set dialtry 0; 				# how often did you dial already
set Iconify 0; 				# iconify program after connection
set showterminal 1;			# show terminal while dialing
set showsmall 1;			# show the small display window
set smallgeometry "+300+300";           # Geometry of info window
set startdelay 4; 			# how long does it take to connect
set showmoneyinicon 1; 			# display time in iconname
set flagwarning 0; 			# time-warning yes/no
set warningtime 60; 			# warningperiod (min)
set refreshtime 1; 			# refresh-delay of onlinetime (sec)
set money "0.00"; 			# how much money does it cost 
set linestatus "LINE down"; 		# status of connection
set transferstatus "down";
set ppp_up "/etc/ppp/ppp-up"; 		# dialing-program
set ppp_down "";                 	# canceling-program
set modeminit ATZ;			# Initstring for modem
set modemfirstinit ATZ;
set dialtype T;				# T: tone, P: pulse
set repeatdelay 1;			# delay between dialing
set modemspeed "38400";			# Speed of line
set modemparity "CS8";			# Parity
set modemstopbits "|";			# How many stopbits
set modemtimeout 60;			# timeout for expect
set classname dummy;                    # active classname
set unitsday 1;                         # which day to edit
set listreturn "dummy";
set zonelength 21;                      # Length of one Unit
set numbernumbers 0;                    # How many phone numbers
set getbytes "       0";                # Bytes received
set sendbytes "       0";               # Bytes sent
set oldgetbytes 0;                
set oldsendbytes 0;
set getbytessave 0;
set sendbytessave 0;
set transfertime 1;                     # refresh of I/O display
set transfercount 0;
set lbcounter 1;                        # Counter for 5 seconds average
set infostate "interface_down";
set middlebytes 0;                      # 5 seconds average
for {set i 1} {$i <= 5} {incr i 1} {
  set lastbytes($i) 0;                  # Array for 5 seconds
}

set classnumber 1;
set nameclass(1) dummy;
for {set i 1} {$i <= 8} {incr i 1} { 
  set dayclass($i) dummy;
}
for {set i 0} {$i < 24} {incr i 1} { 
  set class(dummy,$i) 21;
}

set zonemoney 0.23; 			# How much is one unit
set currency DM; 			# Currency
set pid 0;				# child pid
set terminalpid -1;			# terminalprocess pid
set modemconnect "CONNECT";
set modemcarrier "CARRIER";
set modemnocarrier "NO CARRIER";
set modembusy "BUSY";
set modemnoanswer "NO ANSWER";
set modemnodialtone "NO DIALTONE";
set modemdelayed "DELAYED";
set modemerror "ERROR";
set hangupplus 1;                       # Hangup with ATH
set attentionstring "+++";

# config-files

# common config

if {[catch {open $configfile r} Datei] == 1} {
  tk_dialog .config "Config" "No file $configfile" error 0 ok
} else {
  gets $Datei instdir
  gets $Datei showmoneyinicon
  gets $Datei Iconify
  gets $Datei ppp_up
  gets $Datei ppp_down
  gets $Datei alterrefresh
  gets $Datei flagwarning
  gets $Datei warningtime
  gets $Datei startdelay
  gets $Datei modeminit
  gets $Datei dialtype
  gets $Datei modemdevice
  gets $Datei repeatdelay
  gets $Datei modemspeed
  gets $Datei modemparity
  gets $Datei modemstopbits
  gets $Datei modemtimeout
  gets $Datei showterminal
  gets $Datei modemconnect
  gets $Datei modemcarrier
  gets $Datei modemnocarrier
  gets $Datei modembusy
  gets $Datei modemnoanswer
  gets $Datei modemnodialtone
  gets $Datei modemdelayed
  gets $Datei modemerror
  gets $Datei hangupplus
  gets $Datei attentionstring
  gets $Datei numbernumbers
  for {set i 1} {$i <= $numbernumbers} {incr i 1} {
    gets $Datei dialnumbers($i)
  } 
  gets $Datei modemfirstinit
  gets $Datei transfertime
  gets $Datei showsmall
  gets $Datei smallgeometry
  gets $Datei infoprog
  close $Datei
}

set modemdevicetail [file tail $modemdevice]
if {[catch {expr int($alterrefresh)}] == 0} {
  set refreshtime $alterrefresh
} else {
  set alterrefresh $refreshtime
}

# Ressource

if [catch {option readfile $Ressource startup} err] {
  tk_dialog .config "Config" "$err: change it, but use it!!!" error 0 ok
}


# Pictures

set mypicup [image create photo -file "$instdir/eyenc.ppm"]
set mypicup2 [image create photo -file "$instdir/eyehc.ppm"]
set mypicdown [image create photo -file "$instdir/eyeb1.ppm"]
set mypicdown2 [image create photo -file "$instdir/eyeb2.ppm"]
set mypicturn [image create photo -file "$instdir/eyert.ppm"]
set mypicbothclose [image create photo -file "$instdir/eyebc.ppm"]
set mypicleftclose [image create photo -file "$instdir/eyelc.ppm"]
set mypicrightclose [image create photo -file "$instdir/eyerc.ppm"]

set mypicexit [image create photo -file "$instdir/cancel.ppm"]
set mypicpppup [image create photo -file "$instdir/pppup.ppm"]
set mypicpppdown [image create photo -file "$instdir/pppdown.ppm"]
set mypicpppterm [image create photo -file "$instdir/xterm.ppm"]

# load filerequester

source "$instdir/$widgetfile"


# hints for the window-manager

tk appname $progname
wm title . "$progname $version"
#wm iconbitmap . "@$instdir/pppdownicon"
wm iconname . $progname
wm protocol . WM_DELETE_WINDOW bell

#set temp [wm geometry .]
#wm maxsize . $temp
#wm minsize . $temp

toplevel .icon -background {} -cursor man
frame .icon.frame -background white -relief raised -borderwidth 2
label .icon.frame.image -background white -image $mypicdown
label .icon.frame.text -background white -textvariable icontext
pack .icon.frame -ipadx 8p
pack .icon.frame.image -side top
pack .icon.frame.text -side bottom
wm iconwindow . .icon

toplevel .small -background {} -cursor man
#wm transient .small .
wm iconname .small "Info"
wm title .small "Info"
catch {wm geometry .small $smallgeometry}
frame .small.frame -background white -relief raised -borderwidth 2
label .small.frame.image -background white -image $mypicdown
label .small.frame.text -background white -textvariable icontext
pack .small.frame -ipadx 8p
pack .small.frame.image -side top
pack .small.frame.text -side bottom
wm withdraw .small

# create the icon menu

menu .iconmenu -tearoff false
menu .iconmenu.commands -tearoff false -postcommand {wm deiconify .iconmenu.commands}
.iconmenu add cascade -label "Activities..." -menu .iconmenu.commands
.iconmenu.commands add command -label "Start connection" -command {up}
.iconmenu.commands add command -label "End connection" -command {down}
.iconmenu.commands add command -label "Exit $progname" -command {Exit $moneyfile $transferfile}
.iconmenu add separator
.iconmenu add command -label "Online:\t$onlinetime"
.iconmenu add command -label "Next:\t$lastonlinetime"
.iconmenu add command -label "Money:\t$money"
.iconmenu add command -label "In:\t$getbytes"
.iconmenu add command -label "Out:\t$sendbytes"
.iconmenu add command -label "Average:\t$middlebytes"


# menubar

frame .mbar -relief raised -bd 2

# help-button

menubutton .mbar.help -cursor sb_down_arrow -text Help -underline 0 -menu .mbar.help.menu
menu .mbar.help.menu
.mbar.help.menu add command -label "About $progname $version     " -underline 0 -accelerator Ctrl+a -command {about $version}
.mbar.help.menu add command -label "Help" -underline 0 -accelerator Ctrl+h -command {Help}

# options-button

menubutton .mbar.options -cursor sb_down_arrow -text Options -underline 0 -menu .mbar.options.menu
menu .mbar.options.menu
.mbar.options.menu add checkbutton -label "Iconify" -variable Iconify
.mbar.options.menu add checkbutton -label "Onlinetime in Icon" -variable showmoneyinicon
.mbar.options.menu add checkbutton -label "Show terminal" -variable showterminal
.mbar.options.menu add checkbutton -label "Show info window" -variable showsmall -command {createsmall}

menubutton .mbar.config -cursor sb_down_arrow -text Configs -underline 0 -menu .mbar.config.menu
menu .mbar.config.menu
.mbar.config.menu add command -label "Show money...     " -underline 0 -accelerator Ctrl+s -command {wholemoney $moneyfile $transferfile $currency} 
.mbar.config.menu add separator
.mbar.config.menu add command -label "Alter options...     " -underline 6 -accelerator Ctrl+o -command alteroptions
.mbar.config.menu add command -label "Alter modem...     " -underline 6 -accelerator Ctrl+m -command altermodem
.mbar.config.menu add separator
.mbar.config.menu add command -label "Change state...     " -underline 0 -accelerator Ctrl+c -command changestate
.mbar.config.menu add command -label "Units...     " -underline 0 -accelerator Ctrl+u -command displayunits


focus .mbar

# eventbinding for the menubar

bind . <Control-a> {about $version}
bind . <Control-h> {Help}
bind . <Control-s> {wholemoney $moneyfile $transferfile $currency}
bind . <Control-o> {alteroptions}
bind . <Control-m> {altermodem}
bind . <Control-x> {Exit $moneyfile $transferfile}
bind . <Control-c> {changestate}
bind . <Control-u> {displayunits}


# eventbinding for the icon 

bind .icon <3> {
  iconmenuupdate
  wm deiconify .iconmenu
  tk_popup .iconmenu %X %Y
  iconmenuupdate
}

bind .small <3> {
  iconmenuupdate
  wm deiconify .iconmenu
  tk_popup .iconmenu %X %Y
  iconmenuupdate
}

#bind .icon <Enter> {
#  iconenter
#}
#bind .icon <Leave> {
#  iconleave
#}

bind .iconmenu <ButtonRelease-3> {
  wm withdraw .iconmenu
  wm withdraw .iconmenu.commands
  .iconmenu activate 1
}


# buttons for the functions

frame .button
button .button.up -cursor target -image $mypicpppup -command {up}
button .button.down -cursor target -image $mypicpppdown -command {down}
button .button.terminal -cursor target -image $mypicpppterm -command {displayterm}
button .button.exit -cursor target -image $mypicexit -command {Exit $moneyfile $transferfile}

# display information

frame .info -cursor cross -relief ridge -borderwidth 4 

# connection-data, from <ip>

frame .info.status -relief sunken -borderwidth 4   
frame .info.status.unitlength
label .info.status.unitlength.label -text "Length of one unit (sec):"
label .info.status.unitlength.output -textvariable zonelength -width 5 -anchor w
frame .info.status.ifname
label .info.status.ifname.label -text "Interface / Speed:"
label .info.status.ifname.output1 -textvariable Ifname -width 4 -anchor w
label .info.status.ifname.output2 -textvariable Pppspeed
frame .info.status.ttyname
label .info.status.ttyname.label -text "Device:"
label .info.status.ttyname.output -textvariable Ttydev
#label .info.status.ttyname.output -textvariable getbytes
frame .info.status.pppspeed
label .info.status.pppspeed.label -text "Speed:"
label .info.status.pppspeed.output -textvariable Pppspeed
#label .info.status.pppspeed.output -textvariable sendbytes
frame .info.status.localip
label .info.status.localip.label -text "Local IP:"
label .info.status.localip.output -textvariable Localip
frame .info.status.remoteip
label .info.status.remoteip.label -text "Remote IP:"
label .info.status.remoteip.output -textvariable Remoteip
frame .info.status.transfer
label .info.status.transfer.label -text "I/O:"
label .info.status.transfer.outputi -textvariable getbytes
label .info.status.transfer.outputo -textvariable sendbytes
frame .info.status.middle
label .info.status.middle.label -text "Average (kb/s):"
label .info.status.middle.output -textvariable middlebytes
frame .info.status.message -relief ridge -bd 2
label .info.status.message.label -text "          "
label .info.status.message.output -textvariable message

# display status

frame .info.action -relief groove -borderwidth 4  

frame .info.action.ppp -relief ridge -borderwidth 3
label .info.action.ppp.info -image $mypicdown

frame .info.action.time
label .info.action.time.label -text "Time:	"
label .info.action.time.time -textvariable Time
frame .info.action.onlinetime
label .info.action.onlinetime.label -text "Online:	"
label .info.action.onlinetime.time -textvariable onlinetime -width 10 -anchor w
frame .info.action.lastonlinetime
label .info.action.lastonlinetime.label -text "Next:	"
label .info.action.lastonlinetime.time -textvariable lastonlinetime -width 10 -anchor w
frame .info.action.money
label .info.action.money.label -text "Money:	"
label .info.action.money.money -textvariable money
frame .info.action.dialtry
label .info.action.dialtry.label -text "Dialing:	"
label .info.action.dialtry.dialtry -textvariable dialtry

bind .info.action.ppp.info <Enter> {
  goodieenter
}
bind .info.action.ppp.info <Leave> {
  goodieleave
}


# the whole packing

pack .mbar -side top -fill x
pack .mbar.help -side right
pack .mbar.options -side left
pack .mbar.config -side left

pack .button -side bottom -fill x
pack .button.up -side left -padx 20 -pady 10
pack .button.down -side left -padx 10 -pady 10
pack .button.terminal -side left -padx 20 -pady 10

pack .button.exit -side right -padx 10 -pady 10

pack .info -side top -fill x -fill y -pady 5 -padx 5
pack .info.status -side left -fill y -anchor w
pack .info.action -side right -anchor e
pack .info.status.unitlength -side top -anchor w -pady 0
pack .info.status.unitlength.label -side left
pack .info.status.unitlength.output -side left
pack .info.status.ifname -side top -anchor w -pady 0
pack .info.status.ifname.label -side left
pack .info.status.ifname.output1 -side left
pack .info.status.ifname.output2 -side left
pack .info.status.ttyname -side top -anchor w -pady 0
pack .info.status.ttyname.label -side left
pack .info.status.ttyname.output -side left
#pack .info.status.pppspeed -side top -anchor w -pady 0
#pack .info.status.pppspeed.label -side left
#pack .info.status.pppspeed.output -side left
pack .info.status.localip -side top -anchor w -pady 0
pack .info.status.localip.label -side left
pack .info.status.localip.output -side left
pack .info.status.remoteip -side top -anchor w -pady 0
pack .info.status.remoteip.label -side left
pack .info.status.remoteip.output -side left
pack .info.status.transfer -side top -anchor w -pady 0
pack .info.status.transfer.label -side left
pack .info.status.transfer.outputi -side left
pack .info.status.transfer.outputo -side left
pack .info.status.middle -side top -anchor w -pady 0
pack .info.status.middle.label -side left
pack .info.status.middle.output -side left
pack .info.status.message -side top -fill x -anchor w -pady 0
pack .info.status.message.label -side left
pack .info.status.message.output -side left -fill x

pack .info.action.ppp -side top -anchor w
pack .info.action.ppp.info 
pack .info.action.time -side top -anchor w -pady 10
pack .info.action.time.label -side left 
pack .info.action.time.time -side left 
pack .info.action.onlinetime -side top -anchor w
pack .info.action.onlinetime.label -side left 
pack .info.action.onlinetime.time -side left
pack .info.action.lastonlinetime -side top -anchor w
pack .info.action.lastonlinetime.label -side left 
pack .info.action.lastonlinetime.time -side left
pack .info.action.money -side top -anchor w
pack .info.action.money.label -side left 
pack .info.action.money.money -side left 
pack .info.action.dialtry -side top -anchor w
pack .info.action.dialtry.label -side left 
pack .info.action.dialtry.dialtry -side left 

# the terminal

toplevel .sm -takefocus 0 
wm withdraw .sm
wm title .sm "terminal"
toplevel .icon2 -background lightblue -cursor man
label .icon2.image -background lightblue -image $mypicpppterm
pack .icon2.image
wm iconwindow .sm .icon2

wm geometry .sm +300+100
#wm focusmodel .sm active
wm protocol .sm WM_DELETE_WINDOW bell
frame .sm.input -takefocus 0 
text .sm.input.text -takefocus 0 -relief raised -bd 2 \
    -xscrollcommand ".sm.input.scroll2 set" -yscrollcommand ".sm.input.scroll1 set" 
scrollbar .sm.input.scroll1 -takefocus 0 -command ".sm.input.text yview"
scrollbar .sm.input.scroll2 -takefocus 0 -orient horizontal -command ".sm.input.text xview"
frame .sm.buttons -takefocus 0  
button .sm.buttons.exit -cursor target -takefocus 0 -text "Close" -command {wm withdraw .sm}
button .sm.buttons.expect -cursor target -takefocus 0 -text "Stop Expect" -command {stopexpect}
button .sm.buttons.terminate -cursor target -takefocus 0 -text "Transparent" -command {set message [killterminal]}
button .sm.buttons.up -cursor target -takefocus 0 -text "Line up" -command {lineup}
button .sm.buttons.endfile -width 20 -cursor target -takefocus 0 -text "Start $ppp_up" -command {startfile}

pack .sm.input -side top
pack .sm.input.scroll2 -side bottom -fill x
pack .sm.input.scroll1 -side right -fill y
pack .sm.input.text -side left
pack .sm.buttons -fill x -ipadx 1c -pady 1m -side bottom
pack .sm.buttons.exit -padx 10 -pady 10 -side right
pack .sm.buttons.expect -pady 10 -padx 10 -side left
pack .sm.buttons.terminate -pady 10 -padx 10 -side left
pack .sm.buttons.up -pady 10 -padx 10 -side left
pack .sm.buttons.endfile -pady 10 -padx 10 -side left

bindtags .sm.input.text {
  #nothing
}

bind .sm <Any-KeyPress> {sendmodem %A}



# the functions

# dial ppp 

proc up {} {
    global terminalpid linestatus message showterminal pid modemdevicetail modemdevice
    if {$linestatus == "LINE up"} {
	set message "line already active"
	return
    } else {
	if {$terminalpid == -1} {
	    set terminalpid [modeminit]
	    set message $terminalpid
	}
	set modemdevicetail [file tail $modemdevice]
	if {$showterminal == 1} displayterm
	set pid [dialproc]
	set message $pid
    }
}


proc up2 {} {
  global message ppp_up mypicup mypicturn instdir
  set message [killterminal]
  #exec $ppp_up &
  helperup
    
  .info.action.ppp.info configure -image $mypicturn
  .icon.frame.image configure -image $mypicturn
  .small.frame.image configure -image $mypicturn
  after 1000 {
    .info.action.ppp.info configure -image $mypicup
    .icon.frame.image configure -image $mypicup
    .small.frame.image configure -image $mypicup
  }
}


# cancel ppp 

proc down {} {
  global message pid ppp_down dialtry
  global linestatus instdir mypicturn mypicup mypicdown startwarn 
  global modemdevice Ifname Ttydev Pppspeed Localip Remoteip hangupplus
  set dialtry 0

  if {$hangupplus == 0} {
    set message [modemhangup]
  }

  if {$pid != 0} {
    catch {killpid} message
  }
  helperdown
  if {$ppp_down != ""} {
      if [catch {exec $ppp_down &} result] {
	  error "ppp-down: $result"
      }
  }
  killterminal

  if {$hangupplus != 0} {
    set message [modemhangup2]
  } else {   
      # it's paranoia, isn't it?
      after 1000 { for {set i 1} {$i <= 5} {incr i 1} {
	  set message [modemhangup]
	  if {$message == "Hangup"} {
	      break;
	  }
      }
      }
  }

  set pid 0
  set info_linestatus [catch {exec netstat -nr | grep ppp0} result]
  if {$info_linestatus == 1} {
    if {$linestatus != "LINE down"} {
      set linestatus "LINE down"
      .info.action.ppp.info configure -image $mypicturn
      .icon.frame.image configure -image $mypicturn
      .small.frame.image configure -image $mypicturn
      after 1000 {
        .info.action.ppp.info configure -image $mypicdown
        .icon.frame.image configure -image $mypicdown
        .small.frame.image configure -image $mypicdown
      }
    }
    set Ifname ""
    set Ttydev ""
    set Pppspeed ""
    set Localip ""
    set Remoteip ""
    startonlinetime
  }
}

 
# is there already a ppp-connection?

proc pppinfo {} {
  global mypicturn linestatus instdir mypicup mypicdown startwarn 
  global Ifname Ttydev Pppspeed Localip Remoteip
  set info_linestatus [catch {exec netstat -nr | grep ppp0}]
  if {$info_linestatus == 1} {
    set linestatus "LINE down"
    .info.action.ppp.info configure -image $mypicdown
    .icon.frame.image configure -image $mypicdown
    .small.frame.image configure -image $mypicdown
    set Ifname ""
    set Ttydev ""
    set Pppspeed ""
    set Localip ""
    set Remoteip ""
  } else {
    set linestatus "LINE up"
    transferUp
    .info.action.ppp.info configure -image $mypicturn
    .icon.frame.image configure -image $mypicturn
    .small.frame.image configure -image $mypicturn
    after 1000 {
      .info.action.ppp.info configure -image $mypicup
      .icon.frame.image configure -image $mypicup
      .small.frame.image configure -image $mypicup
    }
  }
  startonlinetime
}   

# starting the online-time

proc startonlinetime {} {
  global zonemoney moneyfile transferfile money linestatus lastonlinetime onlinetime onlinemoneytime
  global infoprog middlebytes starttime startwarn startdelay getbytessave sendbytessave
  if {$linestatus == "LINE down"} {
    set onlinetime "00:00:00"
    set lastonlinetime "00:00:00"
    savemoney $moneyfile $money 
    savetransfer $transferfile $sendbytessave $getbytessave
    set getbytessave 0
    set sendbytessave 0
    set money "0.00"
    set middlebytes 0
    set onlinemoneytime 0
    infoDown
   } else {
    set money $zonemoney
    set onlinemoneytime 0
    set startwarn [expr [gettime] -$startdelay]
    after [expr 60000 - (($startdelay - 1) * 1000)] warningguard
    set starttime [expr [gettime] - $startdelay]
    onlinetime
       if {$infoprog != ""} {
       infoUp
    }
  }
}   

# Save the configfile

proc savemoney {moneyfile money} {
  global starttime
  if {$money != "0.00"} {
    lappend temp $money
    lappend temp [exec date]
    set temp2 [onlineshowtime raw $starttime]
    lappend temp $temp2
    set Datei [open $moneyfile a+]
    puts $Datei "$temp" 
    close $Datei
  }
}
# Save the transferfile

proc savetransfer {transferfile getbytessave sendbytessave} {
  if {(int($getbytessave) != 0) && (int($sendbytessave) != 0)} {
    lappend temp $getbytessave
    lappend temp $sendbytessave
    lappend temp [exec date]
    set Datei [open $transferfile a+]
    puts $Datei "$temp"
    close $Datei
  }
}

  
# display of the connection-data, from <send> at <ip>

proc showppp {} {
  global infostate Iconify linestatus Ifname Ttydev Pppspeed Localip Remoteip
  global getbytessave sendbytessave startwarn mypicup mypicdown mypicturn instdir
  global ifname ttydev pppspeed localip remoteip
  if {$infostate == "interface_up"} {
    set Ifname $ifname
    set Ttydev $ttydev
    set Pppspeed $pppspeed
    set Localip $localip
    set Remoteip $remoteip
    transferUp
  } else {
    transferDown
#    puts $getbytessave
#    puts $sendbytessave
    set linestatus "LINE down"
    .info.action.ppp.info configure -image $mypicturn
    .icon.frame.image configure -image $mypicturn
    .small.frame.image configure -image $mypicturn
    after 1000 {
      .info.action.ppp.info configure -image $mypicdown
      .icon.frame.image configure -image $mypicdown
      .small.frame.image configure -image $mypicdown
    }
    set Ifname ""
    set Ttydev ""
    set Pppspeed ""
    set Localip ""
    set Remoteip ""
    startonlinetime
  }
  if {$Iconify == 1} {
    after 5000 {wm iconify .}
  }
}

# clock

proc Time {} {
  global Time zonelength  

  set Time [string range [getshowtime] 0 4]
  getnewpartzone
  after 60000 {Time}
}

# I/O display

proc transfer {} {
  global transfertime transfercount transferstatus
  global sendbytes oldsendbytes getbytes oldgetbytes
  global lbcounter middlebytes
  global mypicbothclose mypicleftclose mypicrightclose mypicup
    upvar \#0 lastbytes llastbytes

  #  ([winfo viewable .] == 1)
  if {($transfertime != 0) && ($transferstatus == "up")} {
    incr transfercount 1
    if {$transfercount >= $transfertime} {
      set transfercount 0
      set oldin $getbytes
      set oldout $sendbytes
      getTransfer
      set llastbytes($lbcounter) [expr ($getbytes - $oldin) + ($sendbytes - $oldout)]
      if {$llastbytes($lbcounter) < 0} {
	set llastbytes($lbcounter) 0
      }
      if {$lbcounter < 5} {
	incr lbcounter 1
      } else {
	set lbcounter 1
      }
      set temp 0
      for {set i 1} {$i <= 5} {incr i 1} {
	set temp [expr $temp + $llastbytes($i)]
      } 
      set middlebytes [expr $temp / (5000.0 * $transfertime)]
    }
    
    if {($transfertime != 0) && ($transferstatus == "up")} {
      set diffsend [expr $sendbytes - $oldsendbytes]
      set diffget  [expr $getbytes  - $oldgetbytes ]

	if {($diffsend != 0) || ($diffget != 0)} {
	    if {$diffsend > $diffget} {
		.info.action.ppp.info configure -image $mypicleftclose
		.icon.frame.image configure -image $mypicleftclose
		.small.frame.image configure -image $mypicleftclose
		after 100 {
		    .info.action.ppp.info configure -image $mypicup
		    .icon.frame.image configure -image $mypicup
		    .small.frame.image configure -image $mypicup
		}
	    } else {
		.info.action.ppp.info configure -image $mypicrightclose
		.icon.frame.image configure -image $mypicrightclose
		.small.frame.image configure -image $mypicrightclose
		after 100 {
		    .info.action.ppp.info configure -image $mypicup
		    .icon.frame.image configure -image $mypicup
		    .small.frame.image configure -image $mypicup
		}
	    }
	}
    }
  }
    set oldsendbytes $sendbytes
    set oldgetbytes $getbytes
    
    after 1000 {transfer}
}

proc iconmenuupdate {} {
  global onlinetime lastonlinetime money getbytes sendbytes middlebytes

  catch {.iconmenu delete 2 7}
  .iconmenu add command -label "Online:\t$onlinetime"
  .iconmenu add command -label "Next:\t$lastonlinetime"
  .iconmenu add command -label "Money:\t$money"
  .iconmenu add command -label "In:\t$getbytes"
  .iconmenu add command -label "Out:\t$sendbytes"
  .iconmenu add command -label "Average:\t$middlebytes"

  if {[winfo viewable .iconmenu] == 1} {
    after 1000 {iconmenuupdate}
  }
}

# warning after some time

proc warningguard {} {
  global linestatus startwarn warningtime flagwarning
  if {($flagwarning == 1) && ($linestatus == "LINE up")} {
    if {[expr [gettime] - $startwarn] > [expr $warningtime * 60]} {
      incr startwarn [expr $warningtime * 60] 
      bell
      after 1000 bell
      after 2000 bell
      after 2500 bell
      after 3000 bell
      after 4000 bell
    }
  } 
  if {$linestatus == "LINE up"} {
    after 60000 {warningguard}
  }
}

# display of online-time

proc onlinetime {} {
  global zonemoney money zonelength zonedaytime onlinetime onlinemoneytime linestatus
  global icontext starttime lastonlinetime refreshtime showmoneyinicon
  if {$linestatus == "LINE down"} {
    set icontext down
    return
  }
  set temp [expr ([onlineshowtime raw $starttime] - $onlinemoneytime) - $zonelength]
  
  if {$temp > 0} {
    incr onlinemoneytime $zonelength
    set money [format "%3.2f" [expr $money + $zonemoney]]
    set temp [expr $temp - $zonelength] 
  }

  if {$refreshtime < 59} {
    set onlinetime [onlineshowtime showsec $starttime]
    set lastonlinetime [showdifftime showsec $temp]
  } else {
    set onlinetime [onlineshowtime showmin $starttime]
    set lastonlinetime [showdifftime showmin $temp]
  }

# still needs too much time !!!

  if {$showmoneyinicon == 1} {
    set icontext $onlinetime
    } else {
    if {$showmoneyinicon == 0} {
      set icontext down
      set showmoneyinicon 2
    }
  }

  after [expr $refreshtime * 1000] onlinetime
} 

# show the about-text (copyright)

proc about {version} {
  global progname
  toplevel .top3 -cursor man
  wm transient .top3 .
  wm title .top3 "about"
  wm geometry .top3 +300+300
  button .top3.exit -cursor target -text "OK" -command {destroy .top3}
  message .top3.help1 -relief raised -justify left -width 13c -bd 2 -font \
          -b&h-lucida-bold-r-normal-*-25-*-*-*-*-*-*-* \
          -text "$progname $version"
  message .top3.help2 -relief raised -justify left -width 13c -bd 2 -font \
          -Adobe-Helvetica-Medium-R-Normal--*-180-* \
          -text "                               by\n
 Matthias Ott \n Gebrder-Grimm-Weg 9\n 91522 Ansbach \n Germany \n
 E-Mail: msott@cip.informatik.uni-erlangen.de \n\n(c) 1995"
  pack .top3.help1 .top3.help2 -side top
  pack .top3.exit -ipadx 1c -pady 1m -side bottom
}

# helptext

proc Help {} {
  global instdir helpfile
  set text ""
  toplevel .top4 -cursor man
  wm transient .top4 .
  wm title .top4 "help"
  wm geometry .top4 +400+200
  button .top4.exit -cursor target -text "OK" -command {destroy .top4}
  message .top4.help -relief raised -justify left -bd 2 
  if {[catch {open $helpfile r} Datei] == 1} {
    tk_dialog .help "Help" "No file $instdir/startppp-help" error 0 ok
    return
  } else {
    while {[gets $Datei line] >=0} {
      set text "$text\n$line"
    }
    close $Datei
  } 
  .top4.help configure -text $text
  pack .top4.help -side top
  pack .top4.exit -ipadx 1c -pady 1m -side bottom

}

# show the money already spent

proc wholemoney {moneyfile transferfile currency} {
  global zonemoney
  set wholemoney 0
  set wholetime 0
  set transferin 0
  set transferout 0

  if {[catch {open $moneyfile r} Datei] == 1} {
    tk_dialog .money "Money" "No file $moneyfile" error 0 ok
    return
  } elseif {[catch {open $transferfile r} Datei2] == 1} {
    tk_dialog .money "Money" "No file $transferfile" error 0 ok
    return
  } else {
    while {[gets $Datei number] >=0} {
      set wholemoney [expr $wholemoney + [lindex $number 0]]
      if {[llength $number] > 2} {
        set temp [lindex $number 2]
        set wholetime [expr $wholetime + $temp]
      }
    }
    while {[gets $Datei2 number] >=0} {
      set transferout [expr $transferout + [lindex $number 0]]
      if {[llength $number] > 1} {
        set temp [lindex $number 1]
        set transferin [expr $transferin + $temp]
      }
    }
    close $Datei
    close $Datei2
    set result [expr $wholemoney / $zonemoney]
    set wholetime [showdifftime showsec [expr -1 * $wholetime]]
    tk_dialog .money "Money" "Money spent: [format "%5.2f" $wholemoney] $currency\n\n          Units: [expr int($result)]\n\n          Time: $wholetime\n\n          Bytes (out): $transferout\n\n          Bytes (in): $transferin" info 0 ok
  }
}

# Exit startppp

proc Exit {moneyfile transferfile} {
  global pid message mypicup mypicdown mypicpppup mypicpppdown mypicexit
  global money getbytessave sendbytessave onlinetime modemdevice 
  if {[tk_dialog .exit "Exit?" "Really quit?" questhead 1 yes no] == 0} {
    if {$pid != 0} {
      catch {killpid} message
      set pid 0
    }
    modemclose [file tail $modemdevice]
    set message [killterminal]
    savemoney $moneyfile $money     
    savetransfer $transferfile $sendbytessave $getbytessave
    image delete $mypicup
    image delete $mypicdown 
    image delete $mypicpppup
    image delete $mypicpppdown 
    image delete $mypicexit 
    deleteinfopipe
    exit
  }
}

proc altermodem {} {

  toplevel .am 
  wm transient .am .
  wm title .am "config modem"
  wm geometry .am +300+100
  grab .am
  
  frame .am.text 
  label .am.text.label -text "Alter the modemconfigs:"

  frame .am.buttons
  frame .am.buttons.z1  
  entry .am.buttons.z1.value -width 20 -textvariable modeminit
  label .am.buttons.z1.entry -cursor question_arrow -text " Dialprefix  "

  frame .am.buttons.z12  
  entry .am.buttons.z12.value -width 20 -textvariable modemfirstinit
  label .am.buttons.z12.entry -cursor question_arrow -text " Initstring  "

  frame .am.buttons.z3  
  radiobutton .am.buttons.z3.button -cursor question_arrow -text "Tone" -variable dialtype -value T

  frame .am.buttons.z4  
  radiobutton .am.buttons.z4.button -cursor question_arrow -text "Pulse" -variable dialtype -value P

  frame .am.buttons.z5  
  entry .am.buttons.z5.value -width 20 -textvariable modemdevice
  label .am.buttons.z5.entry -cursor question_arrow -text " Modem"

  frame .am.buttons.z6  
  scale .am.buttons.z6.scale -length 9c -relief ridge -label " Delay of dialrepeat (sec)" -from 0 -to 60 -orient horizontal -variable repeatdelay

  frame .am.buttons.z7
  label .am.buttons.z7.entry -cursor question_arrow -text " Linespeed"
  radiobutton .am.buttons.z7.button1 -cursor question_arrow -text "38400" -variable modemspeed -value 38400
  radiobutton .am.buttons.z7.button2 -cursor question_arrow -text "19200" -variable modemspeed -value 19200
  radiobutton .am.buttons.z7.button3 -cursor question_arrow -text "9600" -variable modemspeed -value 9600
  radiobutton .am.buttons.z7.button4 -cursor question_arrow -text "1200" -variable modemspeed -value 1200

  frame .am.buttons.z8
  label .am.buttons.z8.entry -cursor question_arrow -text " Parity"
  radiobutton .am.buttons.z8.button1 -cursor question_arrow -text "None" -variable modemparity -value CS8
  radiobutton .am.buttons.z8.button2 -cursor question_arrow -text "Even" -variable modemparity -value CS7|PARENB
  radiobutton .am.buttons.z8.button3 -cursor question_arrow -text "Odd" -variable modemparity -value CS7|PARENB|PARODD

  frame .am.buttons.z9
  label .am.buttons.z9.entry -cursor question_arrow -text " Stop bits"
  radiobutton .am.buttons.z9.button1 -cursor question_arrow -text "One" -variable modemstopbits -value |
  radiobutton .am.buttons.z9.button2 -cursor question_arrow -text "Two" -variable modemstopbits -value CSTOPB

  frame .am.buttons.z10  
  scale .am.buttons.z10.scale -length 9c -relief ridge -label " timeout for expect (sec)" -from 0 -to 200 -orient horizontal -variable modemtimeout

  frame .am.buttons.z11 
  checkbutton .am.buttons.z11.button -cursor question_arrow -text "Hangup with AttentionString: " -variable hangupplus
  entry .am.buttons.z11.value -width 5 -textvariable attentionstring

  frame .am.advanced
  button .am.advanced.start -cursor target -text "Advanced ..." -command {modemadvanced}

  frame .am.dialnumbers
  button .am.dialnumbers.start -cursor target -text "Edit phone numbers ..." -command {dialnumbers}

  frame .am.options 
  button .am.options.ok -cursor target -text Ok -command {destroy .am}
  button .am.options.save -cursor target -text Save -command {saveconfigfile}


  pack .am.text -side top
  pack .am.text.label -side left
  pack .am.buttons -pady 5
  pack .am.buttons.z5 .am.buttons.z12 .am.buttons.z1 .am.buttons.z3 .am.buttons.z4 .am.buttons.z6 -side top -fill x
  pack .am.buttons.z7 .am.buttons.z8 .am.buttons.z9 .am.buttons.z10 .am.buttons.z11 -side top -fill x
  pack .am.buttons.z12.entry -side left
  pack .am.buttons.z12.value -side right -padx 10
  pack .am.buttons.z1.entry -side left
  pack .am.buttons.z1.value -side right -padx 10
  pack .am.buttons.z3.button -side left 
  pack .am.buttons.z4.button -side left 
  pack .am.buttons.z5.entry -side left
  pack .am.buttons.z5.value -side right -padx 10
  pack .am.buttons.z6.scale -side left
  pack .am.buttons.z7.entry -side top
  pack .am.buttons.z7.button1 -side left
  pack .am.buttons.z7.button2 -side left
  pack .am.buttons.z7.button3 -side left
  pack .am.buttons.z7.button4 -side left
  pack .am.buttons.z8.entry -side top
  pack .am.buttons.z8.button1 -side left
  pack .am.buttons.z8.button2 -side left
  pack .am.buttons.z8.button3 -side left
  pack .am.buttons.z9.entry -side top
  pack .am.buttons.z9.button1 -side left
  pack .am.buttons.z9.button2 -side left
  pack .am.buttons.z10.scale -side left
  pack .am.buttons.z11.button -side left
  pack .am.buttons.z11.value -side right -padx 10

  pack .am.dialnumbers -side top -fill x -pady 5
  pack .am.dialnumbers.start -side right -padx 5

  pack .am.advanced -side top -fill x -pady 5
  pack .am.advanced.start -side right -padx 5

  pack .am.options -side top -fill x -pady 5
  pack .am.options.ok -side right -padx 5
  pack .am.options.save -side left -padx 5

  tkwait window .am
}

# advanced modemconfig

proc modemadvanced {} {
  global modemconnect modemcarrier modemnocarrier modembusy 
  global modemnoanswer modemnodialtone modemdelayed modemerror
  toplevel .am2 
  wm transient .am2 .
  wm title .am2 "advanced modem"
  wm geometry .am2 +300+100
  grab .am2
  
  frame .am2.text 
  label .am2.text.label -text "Advanced config:"

  frame .am2.buttons
  frame .am2.buttons.z1  
  entry .am2.buttons.z1.value -width 20 -textvariable modemconnect
  label .am2.buttons.z1.entry -cursor question_arrow -text " CONNECT  "
  
  frame .am2.buttons.z2  
  entry .am2.buttons.z2.value -width 20 -textvariable modemcarrier
  label .am2.buttons.z2.entry -cursor question_arrow -text " CARRIER  "
  
  frame .am2.buttons.z3  
  entry .am2.buttons.z3.value -width 20 -textvariable modemnocarrier
  label .am2.buttons.z3.entry -cursor question_arrow -text " NO CARRIER  "
  
  frame .am2.buttons.z4  
  entry .am2.buttons.z4.value -width 20 -textvariable modembusy
  label .am2.buttons.z4.entry -cursor question_arrow -text " BUSY  "
  
  frame .am2.buttons.z5  
  entry .am2.buttons.z5.value -width 20 -textvariable modemnoanswer
  label .am2.buttons.z5.entry -cursor question_arrow -text " NO ANSWER  "
  
  frame .am2.buttons.z6  
  entry .am2.buttons.z6.value -width 20 -textvariable modemnodialtone
  label .am2.buttons.z6.entry -cursor question_arrow -text " NO DIALTONE  "
  
  frame .am2.buttons.z7  
  entry .am2.buttons.z7.value -width 20 -textvariable modemdelayed
  label .am2.buttons.z7.entry -cursor question_arrow -text " DELAYED  "
  
  frame .am2.buttons.z8  
  entry .am2.buttons.z8.value -width 20 -textvariable modemerror
  label .am2.buttons.z8.entry -cursor question_arrow -text " ERROR  "

  frame .am2.options 
  button .am2.options.ok -cursor target -text Ok -command {destroy .am2}
  
  pack .am2.text -side top
  pack .am2.text.label -side left
  pack .am2.buttons -pady 5
  pack .am2.buttons.z1 .am2.buttons.z2 .am2.buttons.z3 .am2.buttons.z4 -side top -fill x
  pack .am2.buttons.z5 .am2.buttons.z6 .am2.buttons.z7 .am2.buttons.z8 -side top -fill x
  pack .am2.buttons.z1.entry -side left
  pack .am2.buttons.z1.value -side right -padx 10
  pack .am2.buttons.z2.entry -side left
  pack .am2.buttons.z2.value -side right -padx 10
  pack .am2.buttons.z3.entry -side left
  pack .am2.buttons.z3.value -side right -padx 10
  pack .am2.buttons.z4.entry -side left
  pack .am2.buttons.z4.value -side right -padx 10
  pack .am2.buttons.z5.entry -side left
  pack .am2.buttons.z5.value -side right -padx 10
  pack .am2.buttons.z6.entry -side left
  pack .am2.buttons.z6.value -side right -padx 10
  pack .am2.buttons.z7.entry -side left
  pack .am2.buttons.z7.value -side right -padx 10
  pack .am2.buttons.z8.entry -side left
  pack .am2.buttons.z8.value -side right -padx 10

  pack .am2.options -side top -fill x -pady 5
  pack .am2.options.ok -side right -padx 5
  tkwait window .am2
}

# change the configfile

proc alteroptions {} {
  global transfertime flagwarning nightstart nightstop refreshtime zonedaytime

  toplevel .au 
  wm transient .au .
  wm title .au "config"
  wm geometry .au +300+100
  grab .au
  
  frame .au.text 
  label .au.text.label -text "Alter the configs:"

  frame .au.buttons

  frame .au.buttons.z6 
  checkbutton .au.buttons.z6.button -cursor question_arrow -text "Iconify after connect" -variable Iconify

  frame .au.buttons.z16 
  checkbutton .au.buttons.z16.button -cursor question_arrow -text "Show terminal" -variable showterminal

  frame .au.buttons.z7 
  checkbutton .au.buttons.z7.button -cursor question_arrow -text "Show Onlinetime in Icon" -variable showmoneyinicon

  frame .au.buttons.z18 
  checkbutton .au.buttons.z18.button -cursor question_arrow -text "Show info window" -variable showsmall -command {createsmall}

  frame .au.buttons.z19 
  entry .au.buttons.z19.value -width 10 -textvariable smallgeometry
  label .au.buttons.z19.entry -cursor question_arrow -text " Geometry of info window"

  frame .au.buttons.z20 
  entry .au.buttons.z20.value -width 10 -textvariable infoprog
  label .au.buttons.z20.entry -cursor question_arrow -text " Helper application"

  frame .au.buttons.z8 
  entry .au.buttons.z8.value -width 10 -textvariable ppp_up
  label .au.buttons.z8.entry -cursor question_arrow -text " PPP-Up"

  frame .au.buttons.z9 
  entry .au.buttons.z9.value -width 10 -textvariable ppp_down
  label .au.buttons.z9.entry -cursor question_arrow -text " PPP-Down"

  frame .au.buttons.z17 
  entry .au.buttons.z17.value -width 10 -textvariable startdelay
  label .au.buttons.z17.entry -cursor question_arrow -text " Delay after CONNECT (sec)"

  frame .au.buttons.z10  
  scale .au.buttons.z10.scale -length 13c -relief ridge -label " Refresh of time" -from 1 -to 60 -orient horizontal -variable refreshtime

  frame .au.buttons.z11  
  scale .au.buttons.z11.scale -length 13c -relief ridge -label " Refresh of I/O Info" -from 0 -to 60 -orient horizontal -resolution 1 -variable transfertime

  frame .au.buttons.z13 
  checkbutton .au.buttons.z13.button -cursor question_arrow -text "Warning (in minutes)" -variable flagwarning -command {configwarning $flagwarning}
  scale .au.buttons.z13.scale -length 13c -relief ridge -from 1 -to 120 -orient horizontal -variable warningtime
  
  frame .au.options 
  button .au.options.ok -cursor target -text Ok -command {
    destroy .au
  }
  button .au.options.save -cursor target -text Save -command {saveconfigfile}



  pack .au.text -side top
  pack .au.text.label -side left
  pack .au.buttons -pady 5
  pack .au.buttons.z8 .au.buttons.z9 .au.buttons.z17 -side top -fill x
  pack .au.buttons.z10 -fill x -side top
  pack .au.buttons.z11 -fill x -side top
  pack .au.buttons.z13 .au.buttons.z6 .au.buttons.z16 .au.buttons.z7 .au.buttons.z18 .au.buttons.z19 .au.buttons.z20 -fill x -side top
  pack .au.buttons.z6.button -side left
  pack .au.buttons.z7.button -side left
  pack .au.buttons.z18.button -side left
  pack .au.buttons.z19.entry -side left 
  pack .au.buttons.z19.value -side right -padx 10
  pack .au.buttons.z20.entry -side left 
  pack .au.buttons.z20.value -side right -padx 10
  pack .au.buttons.z8.entry -side left 
  pack .au.buttons.z8.value -side right -padx 10
  pack .au.buttons.z9.entry -side left 
  pack .au.buttons.z9.value -side right -padx 10
  pack .au.buttons.z17.entry -side left 
  pack .au.buttons.z17.value -side right -padx 10
  pack .au.buttons.z10.scale -pady 3 -side left 
  pack .au.buttons.z11.scale -pady 3 -side left 
  pack .au.buttons.z13.button -side top -anchor w
  pack .au.buttons.z13.scale -side top -side left
  pack .au.buttons.z16.button -side left
  
  pack .au.options -side top -fill x -pady 5
  pack .au.options.ok -side right -padx 5
  pack .au.options.save -side left -padx 5

  configwarning $flagwarning
  tkwait window .au

}

# dis/enable warningscale

proc configwarning flagwarning {
  if {$flagwarning == 0} {
    .au.buttons.z13.scale configure -state disabled -troughcolor black
  } else {
    .au.buttons.z13.scale configure -state normal -troughcolor [option get .au.buttons.z10.scale activeBackground Foreground]
  }
} 

# show the realunits

proc realunits {} {
  global nightstart nightstop zonelength zonedaytime 
  upvar #0 zoneday localzoneday
#  getpartzone zonedaytime $nightstart $nightstop $localzoneday(0) $localzoneday(1) $localzoneday(2) $localzoneday(3) $localzoneday(4) $localzoneday(5) $localzoneday(6) 
  getnewpartzone
  tk_dialog .realunits "The real units" "Zonelength: $zonelength" info 0 ok
}
   
# save the configfile (I/O)

proc saveconfigfile {} {
  global configfile
  global refreshtime ppp_up ppp_down instdir showmoneyinicon Iconify
  global modeminit modemfirstinit dialtype startdelay flagwarning warningtime
  global showterminal modemtimeout modemspeed modemparity modemstopbits modemdevice repeatdelay
  global modemconnect modemcarrier modembusy modemnoanswer modemdelayed modemnodialtone modemerror modemnocarrier
  global infoprog transfertime hangupplus attentionstring numbernumbers showsmall smallgeometry
  upvar \#0 dialnumbers localdialnumbers

  set Datei [open $configfile w+]
  puts $Datei $instdir
  puts $Datei $showmoneyinicon
  puts $Datei $Iconify
  puts $Datei $ppp_up
  puts $Datei $ppp_down
  puts $Datei $refreshtime
  puts $Datei $flagwarning
  puts $Datei $warningtime
  puts $Datei $startdelay
  puts $Datei $modeminit
  puts $Datei $dialtype
  puts $Datei $modemdevice
  puts $Datei $repeatdelay
  puts $Datei $modemspeed
  puts $Datei $modemparity
  puts $Datei $modemstopbits
  puts $Datei $modemtimeout
  puts $Datei $showterminal
  puts $Datei $modemconnect
  puts $Datei $modemcarrier
  puts $Datei $modemnocarrier
  puts $Datei $modembusy
  puts $Datei $modemnoanswer
  puts $Datei $modemnodialtone
  puts $Datei $modemdelayed
  puts $Datei $modemerror
  puts $Datei $hangupplus
  puts $Datei $attentionstring
  puts $Datei $numbernumbers
  for {set i 1} {$i <= $numbernumbers} {incr i 1} {
    puts $Datei $localdialnumbers($i)
  } 
  puts $Datei $modemfirstinit
  puts $Datei $transfertime
  puts $Datei $showsmall
  puts $Datei $smallgeometry
  puts $Datei $infoprog
  close $Datei
}
  
# move goodiepicture (enter)

proc goodieenter {} {
  global linestatus mypicdown2 mypicup2
  if {$linestatus == "LINE up"} {
    .info.action.ppp.info configure -image $mypicup2
  } else {
    .info.action.ppp.info configure -image $mypicdown2
  }
}

# move goodiepicture (leave)

proc goodieleave {} {
  global linestatus mypicdown mypicup
  if {$linestatus == "LINE up"} {
    .info.action.ppp.info configure -image $mypicup
  } else {
    .info.action.ppp.info configure -image $mypicdown
  }
}

# move goodiepicture (enter)

proc iconenter {} {
  global linestatus mypicdown2 mypicup2
  if {$linestatus == "LINE up"} {
    .icon.frame.image configure -image $mypicup2
  } else {
    .icon.frame.image configure -image $mypicdown2
  }
}

# move goodiepicture (leave)

proc iconleave {} {
  global linestatus mypicdown mypicup
  if {$linestatus == "LINE up"} {
    .icon.frame.image configure -image $mypicup
  } else {
    .icon.frame.image configure -image $mypicdown
  }
}

proc changestate {} {
  global mypicup mypicdown linestatus mypicturn
  set result [tk_dialog .state "Change state" "Change the state of the line" questhead 2 up down cancel]
  if {$result == 0} {
    set linestatus "LINE up"
    .info.action.ppp.info configure -image $mypicturn
    .icon.frame.image configure -image $mypicturn
    .small.frame.image configure -image $mypicturn
    after 1000 {
      .info.action.ppp.info configure -image $mypicup
      .icon.frame.image configure -image $mypicup
      .small.frame.image configure -image $mypicup
    }
    startonlinetime
  }
  if {$result == 1} {
    down
  }
}

# start the onlinetime, display icon
    
proc lineup {} {
  global mypicup linestatus mypicturn
  if {$linestatus != "LINE up"} {
    set linestatus "LINE up"
    .info.action.ppp.info configure -image $mypicturn
    .icon.frame.image configure -image $mypicturn
    .small.frame.image configure -image $mypicturn
    after 1000 {
      .info.action.ppp.info configure -image $mypicup
      .icon.frame.image configure -image $mypicup
      .small.frame.image configure -image $mypicup
    }
    startonlinetime
  }
}

proc displayterm {} {
  global terminalpid message
  if {$terminalpid == -1} {
    set terminalpid [modeminit]
    set message $terminalpid
  }
  wm deiconify .sm
}
  
proc stopexpect {} {
  global pid
  if {$pid != 0} {
    catch {killpid} message
  }
}

proc startfile {} {
  global ppp_up mypicup mypicturn instdir message
  set message [killterminal]
  #exec $ppp_up &
  helperup

  .info.action.ppp.info configure -image $mypicturn
  .icon.frame.image configure -image $mypicturn
  .small.frame.image configure -image $mypicturn
  after 1000 {
    .info.action.ppp.info configure -image $mypicup
    .icon.frame.image configure -image $mypicup
    .small.frame.image configure -image $mypicup
  }
}

proc displayunits {} {
  toplevel .du 
  wm transient .du .
  wm title .du "Units"
  wm geometry .du +300+100
  grab .du
  
  frame .du.length
  frame .du.curr
  frame .du.input 
  frame .du.input.days
  frame .du.input.class
  frame .du.buttons

  entry .du.length.value -width 10 -textvariable zonemoney
  label .du.length.entry -cursor question_arrow -text " How much costs one unit"
  entry .du.curr.value -width 10 -textvariable currency
  label .du.curr.entry -cursor question_arrow -text " Your currency"

  radiobutton .du.input.days.1 -command {updatelist .du.input.class.box.list} -cursor question_arrow -text "Sunday" -variable unitsday -value 1
  radiobutton .du.input.days.2 -command {updatelist .du.input.class.box.list} -cursor question_arrow -text "Monday" -variable unitsday -value 2 
  radiobutton .du.input.days.3 -command {updatelist .du.input.class.box.list} -cursor question_arrow -text "Tuesday" -variable unitsday -value 3
  radiobutton .du.input.days.4 -command {updatelist .du.input.class.box.list} -cursor question_arrow -text "Wednesday" -variable unitsday -value 4
  radiobutton .du.input.days.5 -command {updatelist .du.input.class.box.list} -cursor question_arrow -text "Thursday" -variable unitsday -value 5
  radiobutton .du.input.days.6 -command {updatelist .du.input.class.box.list} -cursor question_arrow -text "Friday" -variable unitsday -value 6
  radiobutton .du.input.days.7 -command {updatelist .du.input.class.box.list} -cursor question_arrow -text "Saturday" -variable unitsday -value 7
  radiobutton .du.input.days.8 -command {updatelist .du.input.class.box.list} -cursor question_arrow -text "Bank Holidays" -variable unitsday -value 8

  label .du.input.class.name -textvariable classname -relief ridge -width 10 -anchor w

  frame .du.input.class.box
  listbox .du.input.class.box.list -cursor diamond_cross -width 13 -height 10 -yscrollcommand ".du.input.class.box.scroll1 set" -background grey -relief sunken -borderwidth 2 
  scrollbar .du.input.class.box.scroll1 -cursor sb_v_double_arrow -command ".du.input.class.box.list yview"

  frame .du.buttons.1
  button .du.buttons.1.ok -cursor target -text Ok -command {
    getnewpartzone
    destroy .du
  }
  frame .du.buttons.2
  button .du.buttons.2.save -cursor target -text Save -command {
    cd $env(HOME)
    set temp [Load-Save save $unitsfile]
    if {$temp != ""} {
      set unitsfile $temp
      saveunits
    }
  }
  button .du.buttons.2.load -cursor target -text Load -command {
    cd $env(HOME)
    set temp [Load-Save load $unitsfile]
    if {$temp != ""} {
      set unitsfile $temp
      loadunits
    }
  }
  frame .du.buttons.3
  button .du.buttons.3.assign -cursor target -text "Assign Class" -command {
    assignclass
    updatelist .du.input.class.box.list
  }
  button .du.buttons.3.edit -cursor target -text "Edit Classes" -command {
    editunits
    updatelist .du.input.class.box.list
  }

  # all the packing

  pack .du.length -side top -anchor w -fill x
  pack .du.curr -side top -anchor w -fill x
  pack .du.input -side top
  pack .du.input.days -side left -padx 10 -pady 10
  pack .du.input.class -side right -padx 10 -pady 10
  pack .du.buttons -side bottom -pady 5

  pack .du.length.entry -side left 
  pack .du.length.value -side right -padx 20
  pack .du.curr.entry -side left
  pack .du.curr.value -side right -padx 20

  pack .du.input.days.1 -side top -anchor w
  pack .du.input.days.2 -side top -anchor w
  pack .du.input.days.3 -side top -anchor w
  pack .du.input.days.4 -side top -anchor w
  pack .du.input.days.5 -side top -anchor w
  pack .du.input.days.6 -side top -anchor w
  pack .du.input.days.7 -side top -anchor w
  pack .du.input.days.8 -side top -anchor w

  pack .du.input.class.name -fill x -side top
  pack .du.input.class.box -side bottom
  pack .du.input.class.box.scroll1 -side right -fill y
  pack .du.input.class.box.list -side right

  pack .du.buttons.1 -side right
  pack .du.buttons.2 -side right
  pack .du.buttons.3 -side right
  pack .du.buttons.1.ok -side right -pady 5 -anchor w -padx 10
  pack .du.buttons.2.save -side top -pady 5 -anchor w -padx 10
  pack .du.buttons.2.load -side top -pady 5 -fill x -anchor w -padx 10
  pack .du.buttons.3.assign -side top -pady 5 -anchor w -padx 10
  pack .du.buttons.3.edit -side top -pady 5 -fill x -anchor w -padx 10

  updatelist .du.input.class.box.list
  tkwait window .du
}

proc editunits {} {
  toplevel .eu 
  wm transient .eu .
  wm title .eu "EditUnits"
  wm geometry .eu +300+100
  grab .eu

  global deleteclass workclass classname
  upvar #0 nameclass localnameclass 
  upvar #0 class localclass
  upvar #0 dayclass localdayclass
  
  frame .eu.input 
  frame .eu.input.class
  frame .eu.input.class2
  frame .eu.input.change
  frame .eu.buttons

  label .eu.input.class.name -textvariable classname -width 10 -anchor w
  frame .eu.input.class.box
  listbox .eu.input.class.box.list   -cursor diamond_cross -width 13 -height 10 -yscrollcommand ".eu.input.class.box.scroll1 set" -background grey -relief sunken -borderwidth 2 
  scrollbar .eu.input.class.box.scroll1 -cursor sb_v_double_arrow -command ".eu.input.class.box.list yview"

  label .eu.input.class2.name -text "Classes" -width 10 -anchor w
  frame .eu.input.class2.box
  listbox .eu.input.class2.box.list -cursor diamond_cross -width 13 -height 10 -yscrollcommand ".eu.input.class2.box.scroll1 set" -background grey -relief sunken -borderwidth 2 
  scrollbar .eu.input.class2.box.scroll1 -cursor sb_v_double_arrow -command ".eu.input.class2.box.list yview"
  
  button .eu.buttons.ok -cursor target -text Ok -command {
    destroy .eu
  }
  button .eu.buttons.new -cursor target -text "New Class" -command {
    newclass
    newclass2
    updatelist .eu.input.class.box.list
    updateclasses .eu.input.class2.box.list
  }
  button .eu.buttons.add -cursor target -text "Add Time" -command {
    addtime
    updateclasses .eu.input.class2.box.list
    updatelist .eu.input.class.box.list
  }
  button .eu.buttons.delete -cursor target -text "Delete Class" -command {
    catch {set deleteclass [lindex [selection get] 0]}
    deleteclass
    updatelist .eu.input.class.box.list
    updateclasses .eu.input.class2.box.list
  }

  scale .eu.input.change.start -length 13c -relief ridge -label " Starttime" -from 0 -to 24 -orient horizontal -variable addstart
  scale .eu.input.change.end -length 13c -relief ridge -label " Stoptime" -from 0 -to 24 -orient horizontal -variable addend

  frame .eu.input.change.wert 
  entry .eu.input.change.value -width 10 -textvariable addwert
  label .eu.input.change.entry -cursor question_arrow -text " Length (sec)"

  pack .eu.input -side top
  pack .eu.input.class2 -side left -padx 10 -pady 10
  pack .eu.input.class -side left -padx 10 -pady 10
  pack .eu.input.change -side right -padx 10 -pady 10
  pack .eu.buttons -side bottom -pady 5

  pack .eu.input.class.name -side top
  pack .eu.input.class.box -side top
  pack .eu.input.class.box.scroll1 -side right -fill y
  pack .eu.input.class.box.list -side right

  pack .eu.input.class2.name -side top
  pack .eu.input.class2.box -side top
  pack .eu.input.class2.box.scroll1 -side right -fill y
  pack .eu.input.class2.box.list -side right
  
  pack .eu.input.change.start -side top
  pack .eu.input.change.end -side top
  pack .eu.input.change.wert -side top -pady 10
  pack .eu.input.change.entry -side left
  pack .eu.input.change.value -side left
  
  pack .eu.buttons.ok -side right -pady 5 -padx 10
  pack .eu.buttons.new -side left -pady 5 -padx 10
  pack .eu.buttons.add -side left -pady 5 -padx 10
  pack .eu.buttons.delete -side left -pady 5 -padx 10

  bind .eu.input.class2.box.list <Double-Button-1> {
    catch {set workclass [lindex [selection get] 0]}
    updatelist .eu.input.class.box.list
    updateclasses .eu.input.class2.box.list
  }

  bind .eu.input.change.value <Return> {
    addtime
    updateclasses .eu.input.class2.box.list
    updatelist .eu.input.class.box.list
  }  

  set workclass $classname
  updatelist .eu.input.class.box.list
  updateclasses .eu.input.class2.box.list
  tkwait window .eu

}

proc deleteclass {} {
  global deleteclass classnumber
  upvar #0 nameclass localnameclass 

  set number [lindex [.eu.input.class2.box.list curselection] 0]
  if {$number == ""} {
    return
  }
  
  incr number 1
  for {set i $number} {$i < $classnumber} {incr i 1} {
    set localnameclass($i) $localnameclass([expr $i +1])
  }
  incr classnumber -1
}
  

proc assignclass {} {
  toplevel .ac
  wm transient .ac .
  wm title .ac "Assign Class"
  wm geometry .ac +300+100
  grab .ac

  global temp listreturn unitsday
  upvar #0 dayclass localdayclass
  
  frame .ac.class
  frame .ac.label
  frame .ac.buttons
  
  set temp "ok"

  button .ac.buttons.ok -cursor target -text Ok -command {
    destroy .ac
  }
  button .ac.buttons.cancel -cursor target -text Cancel -command {
    set temp "cancel" 
    destroy .ac
  }

  label .ac.label.label -textvariable listreturn -width 10 -anchor w
  
  listbox .ac.class.list -cursor diamond_cross -width 13 -height 10 -yscrollcommand ".ac.class.scroll1 set" -background grey -relief sunken -borderwidth 2 
  scrollbar .ac.class.scroll1 -cursor sb_v_double_arrow -command ".ac.class.list yview"
  
  pack .ac.class -side top
  pack .ac.label -side top
  pack .ac.buttons -side bottom

  pack .ac.class.list -side left
  pack .ac.class.scroll1 -side left -fill y

  pack .ac.label.label -side left -padx 10 -pady 5
  pack .ac.buttons.ok -side right -padx 10 -pady 5
  pack .ac.buttons.cancel -side left -padx 10 -pady 5

  updateclasses .ac.class.list
  set listreturn $localdayclass($unitsday) 

  bind .ac.class.list <Double-Button-1> {
    catch {set listreturn [lindex [selection get] 0]}
  }

  tkwait window .ac

  if {$temp != "cancel"} {
    set localdayclass($unitsday) $listreturn
  }
}

proc addtime {} {
  upvar #0 dayclass localdayclass 
  upvar #0 nameclass localnameclass 
  upvar #0 class localclass
  global workclass
  global addstart addend addwert
  
  if {($addwert == "") || ($addstart >= $addend)} {
    return
  }
  
  for {set i $addstart} {$i < $addend} {incr i 1} { 
    set localclass($workclass,$i) $addwert
  }
    
}

proc newclass2 {} {
  global localname classnumber
  upvar #0 nameclass localnameclass 
  upvar #0 class localclass

  if {$localname == ""} {
    return
  }
  
  incr classnumber 1
  set localnameclass($classnumber) $localname
  for {set i 0} {$i < 24} {incr i 1} {
    set localclass($localname,$i) 21
  }
  set localname ""
}

proc newclass {} {
  toplevel .nc 
#  wm transient .nc .
  wm title .nc "New Class"
  wm geometry .nc +300+100
  grab .nc

  frame .nc.input
  entry .nc.input.enter -width 15 -textvariable localname
  frame .nc.buttons
  button .nc.buttons.ok -cursor target -text Ok -command {
    destroy .nc
  }
  button .nc.buttons.cancel -cursor target -text Cancel -command {
    set localname ""
    destroy .nc
  }

  pack .nc.input -side top
  pack .nc.buttons -side bottom

  pack .nc.input.enter -side left -pady 10

  pack .nc.buttons.ok -side right -pady 10 -padx 5
  pack .nc.buttons.cancel -side right -pady 10 -padx 5

  bind .nc.input.enter <Return> {
    destroy .nc
  }  

  tkwait window .nc
}

proc updatelist {widgetname} {
  global workclass classname unitsday
  upvar #0 nameclass localnameclass 
  upvar #0 class localclass
  upvar #0 dayclass localdayclass

  if {$widgetname == ".du.input.class.box.list"} {
    set classname $localdayclass($unitsday)
  }
  if {$widgetname == ".eu.input.class.box.list"} {
    set classname $workclass
  }
    
  deldata $widgetname

  set i 0
  while {$i < 23} {
    set start $i
    set wert $localclass($classname,$i)
    incr i 1
    while { ($i < 24) && ($localclass($classname,$i) == $wert) } {
      incr i 1
    }
    set temp "$start - $i:   $wert"
    $widgetname insert end $temp
  }
}

proc updateclasses {widgetname} {
  global classnumber
  upvar #0 nameclass localnameclass 

  deldata $widgetname
  set i 1
  while {$i <= $classnumber} {
    $widgetname insert end $localnameclass($i)
    incr i 1
  }
}

proc deldata widgetname {
  set Laenge [$widgetname size]
  for {set i 0} {$i < $Laenge} {incr i 1} {
    $widgetname delete 0
  }
}

proc loadunits {} {
  global unitsfile classnumber
  global zonemoney currency
  upvar #0 dayclass localdayclass 
  upvar #0 nameclass localnameclass 
  upvar #0 class localclass

  if {[catch {open $unitsfile r} Datei] == 1} {
    tk_dialog .units "Units" "No file $unitsfile" error 0 ok
  } else {
    gets $Datei zonemoney
    gets $Datei currency
    for {set i 1} {$i <= 8} {incr i 1} {
      gets $Datei localdayclass($i)
    }
    gets $Datei anzahl
    set classnumber $anzahl
    for {set i 1} {$i <= $anzahl} {incr i 1} {
      gets $Datei name
      set localnameclass($i) $name
      for {set ii 0} {$ii < 24} {incr ii 1} {
	gets $Datei localclass($localnameclass($i),$ii)
      }
    }
    close $Datei
  }
}

proc saveunits {} {
  global unitsfile classnumber
  global zonemoney currency
  upvar #0 dayclass localdayclass 
  upvar #0 nameclass localnameclass 
  upvar #0 class localclass

  set Datei [open $unitsfile w+]
  puts $Datei $zonemoney
  puts $Datei $currency
  for {set i 1} {$i <= 8} {incr i 1} {
    puts $Datei $localdayclass($i)
  }
  puts $Datei $classnumber
  for {set i 1} {$i <= $classnumber} {incr i 1} {
      puts $Datei $localnameclass($i)
      for {set ii 0} {$ii < 24} {incr ii 1} {
	puts $Datei $localclass($localnameclass($i),$ii)
      }
  }
  close $Datei
}

proc dialnumbers {} {
  toplevel .dn
  wm transient .dn .
  wm title .dn "Phone Numbers"
  wm geometry .dn +300+100
  grab .dn

  upvar #0 dialnumbers localdialnumbers
  
  frame .dn.class
  frame .dn.label
  frame .dn.buttons
  
  button .dn.buttons.ok -cursor target -text Ok -command {
    destroy .dn
  }

  frame .dn.enter 
  entry .dn.enter.value -width 10 -textvariable addnumber
  label .dn.enter.entry -cursor question_arrow -text " Enter Number"

  listbox .dn.class.list -cursor diamond_cross -width 13 -height 10 -yscrollcommand ".dn.class.scroll1 set" -background grey -relief sunken -borderwidth 2 
  scrollbar .dn.class.scroll1 -cursor sb_v_double_arrow -command ".dn.class.list yview"
  
  pack .dn.class -side top -pady 10
  pack .dn.label -side top
  pack .dn.enter -side top
  pack .dn.buttons -side bottom

  pack .dn.class.list -side left
  pack .dn.class.scroll1 -side left -fill y

  pack .dn.enter.entry -side left
  pack .dn.enter.value -side left

  pack .dn.buttons.ok -side right -padx 10 -pady 5

  updatenumbers .dn.class.list

  bind .dn.class.list <Double-Button-1> {
    catch {set worknumber [lindex [.dn.class.list curselection] 0]}
    if {$worknumber == ""} {
      break
    }
  
    incr worknumber 1
    for {set i $worknumber} {$i < $numbernumbers} {incr i 1} {
    set dialnumbers($i) $dialnumbers([expr $i +1])
    }
    incr numbernumbers -1
    updatenumbers .dn.class.list
  }
  
  bind .dn.enter.value <Return> {
    addnumber
    updatenumbers .dn.class.list
  }  

  tkwait window .dn

}

proc addnumber {} {
  global numbernumbers addnumber
  upvar #0 dialnumbers localdialnumbers 
  
  if {$addnumber == ""} {
    return
  }
  incr numbernumbers 1 
  set localdialnumbers($numbernumbers) $addnumber
  set addnumber ""
}

proc updatenumbers {widgetname} {
  global numbernumbers
  upvar #0 dialnumbers localdialnumbers 

  deldata $widgetname
  set i 1
  while {$i <= $numbernumbers} {
    $widgetname insert end $localdialnumbers($i)
    incr i 1
  }
}

proc createsmall {} {
  global showsmall
  if {$showsmall == 1} {
    wm deiconify .small
  } else {
    wm withdraw .small
  }
}


# Main-Program

loadunits

pppinfo

# open the modem
if {$terminalpid == -1} {
    set terminalpid [modeminit]
    set message $terminalpid
}

Time
transfer
tkwait visibility .

for {set i 0} {$i <= $argc} {incr i 1} {
  set commandoption [lindex $argv $i]

  if {($commandoption == "-start") || ($commandoption == "-S")} {
    after 2000 {up}
  }
  if {($commandoption == "-close") || ($commandoption == "-C")} {
    down
  }
  if {($commandoption == "-iconic") || ($commandoption == "-i")} {
    wm iconify .
  }
  if {($commandoption == "-Si") || ($commandoption == "-iS")} {
    wm iconify .
    after 2000 {up}
  }
}

createsmall

# set linestatus "LINE up"
# startonlinetime

createinfopipe

